1 #!/bin/ksh -p
2 #
3 # CDDL HEADER START
4 #
5 # The contents of this file are subject to the terms of the
6 # Common Development and Distribution License (the "License").
7 # You may not use this file except in compliance with the License.
8 #
9 # You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
10 # or http://www.opensolaris.org/os/licensing.
11 # See the License for the specific language governing permissions
12 # and limitations under the License.
13 #
14 # When distributing Covered Code, include this CDDL HEADER in each
15 # file and include the License file at usr/src/OPENSOLARIS.LICENSE.
16 # If applicable, add the following below this CDDL HEADER, with the
17 # fields enclosed by brackets "[]" replaced with your own identifying
18 # information: Portions Copyright [yyyy] [name of copyright owner]
19 #
20 # CDDL HEADER END
21 #
22
23 #
24 # Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
25 # Copyright 2008, 2010, Richard Lowe
26 # Copyright 2011 Nexenta Systems, Inc. All rights reserved.
27 # Copyright 2012 Joshua M. Clulow <josh@sysmgr.org>
28 #
29 # Based on the nightly script from the integration folks,
30 # Mostly modified and owned by mike_s.
31 # Changes also by kjc, dmk.
32 #
33 # BRINGOVER_WS may be specified in the env file.
34 # The default is the old behavior of CLONE_WS
35 #
36 # -i on the command line, means fast options, so when it's on the
37 # command line (only), lint and check builds are skipped no matter what
38 # the setting of their individual flags are in NIGHTLY_OPTIONS.
39 #
40 # LINTDIRS can be set in the env file, format is a list of:
41 #
42 # /dirname-to-run-lint-on flag
43 #
44 # Where flag is: y - enable lint noise diff output
45 # n - disable lint noise diff output
46 #
47 # For example: LINTDIRS="$SRC/uts n $SRC/stand y $SRC/psm y"
48 #
49 # OPTHOME and TEAMWARE may be set in the environment to override /opt
50 # and /opt/teamware defaults.
51 #
52
53 #
54 # The CDPATH variable causes ksh's `cd' builtin to emit messages to stdout
55 # under certain circumstances, which can really screw things up; unset it.
56 #
57 unset CDPATH
58
59 # Get the absolute path of the nightly script that the user invoked. This
60 # may be a relative path, and we need to do this before changing directory.
61 nightly_path=`whence $0`
62
63 #
64 # Keep track of where we found nightly so we can invoke the matching
65 # which_scm script. If that doesn't work, don't go guessing, just rely
66 # on the $PATH settings, which will generally give us either /opt/onbld
67 # or the user's workspace.
68 #
69 WHICH_SCM=$(dirname $nightly_path)/which_scm
70 if [[ ! -x $WHICH_SCM ]]; then
71 WHICH_SCM=which_scm
72 fi
73
74 function fatal_error
75 {
76 print -u2 "nightly: $*"
77 exit 1
78 }
79
80 #
81 # Function to do a DEBUG and non-DEBUG build. Needed because we might
82 # need to do another for the source build, and since we only deliver DEBUG or
83 # non-DEBUG packages.
84 #
85 # usage: normal_build
86 #
87 function normal_build {
88
89 typeset orig_p_FLAG="$p_FLAG"
90 typeset crypto_signer="$CODESIGN_USER"
91
92 suffix=""
93
94 # non-DEBUG build begins
95
96 if [ "$F_FLAG" = "n" ]; then
97 set_non_debug_build_flags
98 CODESIGN_USER="$crypto_signer" \
99 build "non-DEBUG" "$suffix-nd" "-nd" "$MULTI_PROTO"
100 if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
101 "$p_FLAG" = "y" ]; then
102 copy_ihv_pkgs non-DEBUG -nd
103 fi
104 else
105 echo "\n==== No non-DEBUG $open_only build ====\n" >> "$LOGFILE"
106 fi
107
108 # non-DEBUG build ends
109
110 # DEBUG build begins
111
112 if [ "$D_FLAG" = "y" ]; then
113 set_debug_build_flags
114 CODESIGN_USER="$crypto_signer" \
115 build "DEBUG" "$suffix" "" "$MULTI_PROTO"
116 if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
117 "$p_FLAG" = "y" ]; then
118 copy_ihv_pkgs DEBUG ""
119 fi
120 else
121 echo "\n==== No DEBUG $open_only build ====\n" >> "$LOGFILE"
122 fi
123
124 # DEBUG build ends
125
126 p_FLAG="$orig_p_FLAG"
127 }
128
129 #
130 # usage: run_hook HOOKNAME ARGS...
131 #
132 # If variable "$HOOKNAME" is defined, insert a section header into
133 # our logs and then run the command with ARGS
134 #
135 function run_hook {
136 HOOKNAME=$1
137 eval HOOKCMD=\$$HOOKNAME
138 shift
139
140 if [ -n "$HOOKCMD" ]; then
141 (
142 echo "\n==== Running $HOOKNAME command: $HOOKCMD ====\n"
143 ( $HOOKCMD "$@" 2>&1 )
144 if [ "$?" -ne 0 ]; then
145 # Let exit status propagate up
146 touch $TMPDIR/abort
147 fi
148 ) | tee -a $mail_msg_file >> $LOGFILE
149
150 if [ -f $TMPDIR/abort ]; then
151 build_ok=n
152 echo "\nAborting at request of $HOOKNAME" |
153 tee -a $mail_msg_file >> $LOGFILE
154 exit 1
155 fi
156 fi
157 }
158
159 #
160 # usage: filelist DESTDIR PATTERN
161 #
162 function filelist {
163 DEST=$1
164 PATTERN=$2
165 cd ${DEST}
166 }
167
168 # function to save off binaries after a full build for later
169 # restoration
170 function save_binaries {
171 # save off list of binaries
172 echo "\n==== Saving binaries from build at `date` ====\n" | \
173 tee -a $mail_msg_file >> $LOGFILE
174 rm -f ${BINARCHIVE}
175 cd ${CODEMGR_WS}
176 filelist ${CODEMGR_WS} '^preserve:' >> $LOGFILE
177 filelist ${CODEMGR_WS} '^preserve:' | \
178 cpio -ocB 2>/dev/null | compress \
179 > ${BINARCHIVE}
180 }
181
182 # delete files
183 # usage: hybridize_files DESTDIR MAKE_TARGET
184 function hybridize_files {
185 DEST=$1
186 MAKETARG=$2
187
188 echo "\n==== Hybridizing files at `date` ====\n" | \
189 tee -a $mail_msg_file >> $LOGFILE
190 for i in `filelist ${DEST} '^delete:'`
191 do
192 echo "removing ${i}." | tee -a $mail_msg_file >> $LOGFILE
193 rm -rf "${i}"
194 done
195 for i in `filelist ${DEST} '^hybridize:' `
196 do
197 echo "hybridizing ${i}." | tee -a $mail_msg_file >> $LOGFILE
198 rm -f ${i}+
199 sed -e "/^# HYBRID DELETE START/,/^# HYBRID DELETE END/d" \
200 < ${i} > ${i}+
201 mv ${i}+ ${i}
202 done
203 }
204
205 # restore binaries into the proper source tree.
206 # usage: restore_binaries DESTDIR MAKE_TARGET
207 function restore_binaries {
208 DEST=$1
209 MAKETARG=$2
210
211 echo "\n==== Restoring binaries to ${MAKETARG} at `date` ====\n" | \
212 tee -a $mail_msg_file >> $LOGFILE
213 cd ${DEST}
214 zcat ${BINARCHIVE} | \
215 cpio -idmucvB 2>/dev/null | tee -a $mail_msg_file >> ${LOGFILE}
216 }
217
218 # rename files we save binaries of
219 # usage: rename_files DESTDIR MAKE_TARGET
220 function rename_files {
221 DEST=$1
222 MAKETARG=$2
223 echo "\n==== Renaming source files in ${MAKETARG} at `date` ====\n" | \
224 tee -a $mail_msg_file >> $LOGFILE
225 for i in `filelist ${DEST} '^rename:'`
226 do
227 echo ${i} | tee -a $mail_msg_file >> ${LOGFILE}
228 rm -f ${i}.export
229 mv ${i} ${i}.export
230 done
231 }
232
233 #
234 # Copy some or all of the source tree.
235 #
236 # Returns 0 for success, non-zero for failure.
237 #
238 # usage: copy_source CODEMGR_WS DESTDIR LABEL SRCROOT
239 #
240 function copy_source {
241 WS=$1
242 DEST=$2
243 label=$3
244 srcroot=$4
245
246 printf "\n==== Creating %s source from %s (%s) ====\n\n" \
247 "$DEST" "$WS" "$label" | tee -a $mail_msg_file >> $LOGFILE
248
249 printf "cleaning out %s\n" "$DEST." >> $LOGFILE
250 rm -rf "$DEST" >> $LOGFILE 2>&1
251
252 printf "creating %s\n" "$DEST." >> $LOGFILE
253 mkdir -p "$DEST" 2>> $LOGFILE
254
255 if (( $? != 0 )) ; then
256 printf "failed to create %s\n" "$DEST" |
257 tee -a $mail_msg_file >> $LOGFILE
258 build_ok=n
259 return 1
260 fi
261 cd "$WS"
262
263 printf "populating %s\n" "$DEST." >> $LOGFILE
264
265 case "$SCM_TYPE" in
266 teamware)
267 find $srcroot -name 's\.*' -a -type f -print | \
268 sed -e 's,SCCS\/s.,,' | \
269 grep -v '/\.del-*' | \
270 cpio -pd $DEST >>$LOGFILE 2>&1
271 if (( $? != 0 )) ; then
272 printf "cpio failed for %s\n" "$DEST" |
273 tee -a $mail_msg_file >> $LOGFILE
274 build_ok=n
275 return 1
276 fi
277 ;;
278 mercurial)
279 copy_source_mercurial $DEST $srcroot
280 if (( $? != 0 )) ; then
281 build_ok=n
282 return 1
283 fi
284 ;;
285 *)
286 build_ok=n
287 echo "Tree copy is not supported for workspace type" \
288 "$SCM_TYPE" | tee -a $mail_msg_file >> $LOGFILE
289 return 1
290 ;;
291 esac
292
293 return 0
294 }
295
296 #
297 # Mercurial-specific copy code for copy_source().
298 #
299 # Returns 0 for success, non-zero for failure.
300 #
301 # usage: copy_source_mercurial destdir srcroot
302 #
303 function copy_source_mercurial {
304 typeset dest=$1
305 typeset srcroot=$2
306
307 hg locate -I "$srcroot" | cpio -pd "$dest" >>$LOGFILE 2>&1
308 if (( $? != 0 )) ; then
309 printf "cpio failed for %s\n" "$dest" |
310 tee -a $mail_msg_file >> $LOGFILE
311 return 1
312 fi
313
314 return 0
315 }
316
317 #
318 # function to create (but not build) the export/crypt source tree.
319 # usage: set_up_source_build CODEMGR_WS DESTDIR MAKE_TARGET
320 # Sets SRC to the modified source tree, for use by the caller when it
321 # builds the tree.
322 #
323 function set_up_source_build {
324 WS=$1
325 DEST=$2
326 MAKETARG=$3
327
328 copy_source $WS $DEST $MAKETARG usr
329 if (( $? != 0 )); then
330 echo "\nCould not copy source tree for source build." |
331 tee -a $mail_msg_file >> $LOGFILE
332 build_ok=n
333 return
334 fi
335
336 SRC=${DEST}/usr/src
337
338 cd $SRC
339 rm -f ${MAKETARG}.out
340 echo "making ${MAKETARG} in ${SRC}." >> $LOGFILE
341 /bin/time $MAKE -e ${MAKETARG} 2>&1 | \
342 tee -a $SRC/${MAKETARG}.out >> $LOGFILE
343 echo "\n==== ${MAKETARG} build errors ====\n" >> $mail_msg_file
344 egrep ":" $SRC/${MAKETARG}.out | \
345 egrep -e "(^${MAKE}:|[ ]error[: \n])" | \
346 egrep -v "Ignoring unknown host" | \
347 egrep -v "warning" >> $mail_msg_file
348
349 echo "clearing state files." >> $LOGFILE
350 find . -name '.make*' -exec rm -f {} \;
351 }
352
353 # Return library search directive as function of given root.
354 function myldlibs {
355 echo "-L$1/lib -L$1/usr/lib"
356 }
357
358 # Return header search directive as function of given root.
359 function myheaders {
360 echo "-I$1/usr/include"
361 }
362
363 #
364 # Function to do the build, including package generation.
365 # usage: build LABEL SUFFIX ND MULTIPROTO
366 # - LABEL is used to tag build output.
367 # - SUFFIX is used to distinguish files (e.g., DEBUG vs non-DEBUG,
368 # open-only vs full tree).
369 # - ND is "-nd" (non-DEBUG builds) or "" (DEBUG builds).
370 # - If MULTIPROTO is "yes", it means to name the proto area according to
371 # SUFFIX. Otherwise ("no"), (re)use the standard proto area.
372 #
373 function build {
374 LABEL=$1
375 SUFFIX=$2
376 ND=$3
377 MULTIPROTO=$4
378 INSTALLOG=install${SUFFIX}-${MACH}
379 NOISE=noise${SUFFIX}-${MACH}
380 PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
381
382 ORIGROOT=$ROOT
383 [ $MULTIPROTO = no ] || export ROOT=$ROOT$SUFFIX
384
385 if [[ "$O_FLAG" = y ]]; then
386 echo "\nSetting CLOSEDROOT= ${ROOT}-closed\n" >> $LOGFILE
387 export CLOSEDROOT=${ROOT}-closed
388 fi
389
390 export ENVLDLIBS1=`myldlibs $ROOT`
391 export ENVCPPFLAGS1=`myheaders $ROOT`
392
393 this_build_ok=y
394 #
395 # Build OS-Networking source
396 #
397 echo "\n==== Building OS-Net source at `date` ($LABEL) ====\n" \
398 >> $LOGFILE
399
400 rm -f $SRC/${INSTALLOG}.out
401 cd $SRC
402 /bin/time $MAKE -e install 2>&1 | \
403 tee -a $SRC/${INSTALLOG}.out >> $LOGFILE
404
405 if [[ "$SCM_TYPE" = teamware ]]; then
406 echo "\n==== SCCS Noise ($LABEL) ====\n" >> $mail_msg_file
407 egrep 'sccs(check:| *get)' $SRC/${INSTALLOG}.out >> \
408 $mail_msg_file
409 fi
410
411 echo "\n==== Build errors ($LABEL) ====\n" >> $mail_msg_file
412 egrep ":" $SRC/${INSTALLOG}.out |
413 egrep -e "(^${MAKE}:|[ ]error[: \n])" | \
414 egrep -v "Ignoring unknown host" | \
415 egrep -v "cc .* -o error " | \
416 egrep -v "warning" >> $mail_msg_file
417 if [ "$?" = "0" ]; then
418 build_ok=n
419 this_build_ok=n
420 fi
421 grep "bootblock image is .* bytes too big" $SRC/${INSTALLOG}.out \
422 >> $mail_msg_file
423 if [ "$?" = "0" ]; then
424 build_ok=n
425 this_build_ok=n
426 fi
427
428 if [ "$W_FLAG" = "n" ]; then
429 echo "\n==== Build warnings ($LABEL) ====\n" >>$mail_msg_file
430 egrep -i warning: $SRC/${INSTALLOG}.out \
431 | egrep -v '^tic:' \
432 | egrep -v "symbol (\`|')timezone' has differing types:" \
433 | egrep -v "parameter <PSTAMP> set to" \
434 | egrep -v "Ignoring unknown host" \
435 | egrep -v "redefining segment flags attribute for" \
436 >> $mail_msg_file
437 fi
438
439 echo "\n==== Ended OS-Net source build at `date` ($LABEL) ====\n" \
440 >> $LOGFILE
441
442 echo "\n==== Elapsed build time ($LABEL) ====\n" >>$mail_msg_file
443 tail -3 $SRC/${INSTALLOG}.out >>$mail_msg_file
444
445 if [ "$i_FLAG" = "n" -a "$W_FLAG" = "n" ]; then
446 rm -f $SRC/${NOISE}.ref
447 if [ -f $SRC/${NOISE}.out ]; then
448 mv $SRC/${NOISE}.out $SRC/${NOISE}.ref
449 fi
450 grep : $SRC/${INSTALLOG}.out \
451 | egrep -v '^/' \
452 | egrep -v '^(Start|Finish|real|user|sys|./bld_awk)' \
453 | egrep -v '^tic:' \
454 | egrep -v '^mcs' \
455 | egrep -v '^LD_LIBRARY_PATH=' \
456 | egrep -v 'ar: creating' \
457 | egrep -v 'ar: writing' \
458 | egrep -v 'conflicts:' \
459 | egrep -v ':saved created' \
460 | egrep -v '^stty.*c:' \
461 | egrep -v '^mfgname.c:' \
462 | egrep -v '^uname-i.c:' \
463 | egrep -v '^volumes.c:' \
464 | egrep -v '^lint library construction:' \
465 | egrep -v 'tsort: INFORM:' \
466 | egrep -v 'stripalign:' \
467 | egrep -v 'chars, width' \
468 | egrep -v "symbol (\`|')timezone' has differing types:" \
469 | egrep -v 'PSTAMP' \
470 | egrep -v '|%WHOANDWHERE%|' \
471 | egrep -v '^Manifying' \
472 | egrep -v 'Ignoring unknown host' \
473 | egrep -v 'Processing method:' \
474 | egrep -v '^Writing' \
475 | egrep -v 'spellin1:' \
476 | egrep -v '^adding:' \
477 | egrep -v "^echo 'msgid" \
478 | egrep -v '^echo ' \
479 | egrep -v '\.c:$' \
480 | egrep -v '^Adding file:' \
481 | egrep -v 'CLASSPATH=' \
482 | egrep -v '\/var\/mail\/:saved' \
483 | egrep -v -- '-DUTS_VERSION=' \
484 | egrep -v '^Running Mkbootstrap' \
485 | egrep -v '^Applet length read:' \
486 | egrep -v 'bytes written:' \
487 | egrep -v '^File:SolarisAuthApplet.bin' \
488 | egrep -v -i 'jibversion' \
489 | egrep -v '^Output size:' \
490 | egrep -v '^Solo size statistics:' \
491 | egrep -v '^Using ROM API Version' \
492 | egrep -v '^Zero Signature length:' \
493 | egrep -v '^Note \(probably harmless\):' \
494 | egrep -v '::' \
495 | egrep -v -- '-xcache' \
496 | egrep -v '^\+' \
497 | egrep -v '^cc1: note: -fwritable-strings' \
498 | egrep -v 'svccfg-native -s svc:/' \
499 | sort | uniq >$SRC/${NOISE}.out
500 if [ ! -f $SRC/${NOISE}.ref ]; then
501 cp $SRC/${NOISE}.out $SRC/${NOISE}.ref
502 fi
503 echo "\n==== Build noise differences ($LABEL) ====\n" \
504 >>$mail_msg_file
505 diff $SRC/${NOISE}.ref $SRC/${NOISE}.out >>$mail_msg_file
506 fi
507
508 #
509 # Re-sign selected binaries using signing server
510 # (gatekeeper builds only)
511 #
512 if [ -n "$CODESIGN_USER" -a "$this_build_ok" = "y" ]; then
513 echo "\n==== Signing proto area at `date` ====\n" >> $LOGFILE
514 signing_file="${TMPDIR}/signing"
515 rm -f ${signing_file}
516 export CODESIGN_USER
517 signproto $SRC/tools/codesign/creds 2>&1 | \
518 tee -a ${signing_file} >> $LOGFILE
519 echo "\n==== Finished signing proto area at `date` ====\n" \
520 >> $LOGFILE
521 echo "\n==== Crypto module signing errors ($LABEL) ====\n" \
522 >> $mail_msg_file
523 egrep 'WARNING|ERROR' ${signing_file} >> $mail_msg_file
524 if (( $? == 0 )) ; then
525 build_ok=n
526 this_build_ok=n
527 fi
528 fi
529
530 #
531 # Building Packages
532 #
533 if [ "$p_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
534 if [ -d $SRC/pkg -o -d $SRC/pkgdefs ]; then
535 echo "\n==== Creating $LABEL packages at `date` ====\n" \
536 >> $LOGFILE
537 echo "Clearing out $PKGARCHIVE ..." >> $LOGFILE
538 rm -rf $PKGARCHIVE >> "$LOGFILE" 2>&1
539 mkdir -p $PKGARCHIVE >> "$LOGFILE" 2>&1
540
541 for d in pkg pkgdefs; do
542 if [ ! -f "$SRC/$d/Makefile" ]; then
543 continue
544 fi
545 rm -f $SRC/$d/${INSTALLOG}.out
546 cd $SRC/$d
547 /bin/time $MAKE -e install 2>&1 | \
548 tee -a $SRC/$d/${INSTALLOG}.out >> $LOGFILE
549 done
550
551 echo "\n==== package build errors ($LABEL) ====\n" \
552 >> $mail_msg_file
553
554 for d in pkg pkgdefs; do
555 if [ ! -f "$SRC/$d/Makefile" ]; then
556 continue
557 fi
558
559 egrep "${MAKE}|ERROR|WARNING" $SRC/$d/${INSTALLOG}.out | \
560 grep ':' | \
561 grep -v PSTAMP | \
562 egrep -v "Ignoring unknown host" \
563 >> $mail_msg_file
564 done
565 else
566 #
567 # Handle it gracefully if -p was set but there are
568 # neither pkg nor pkgdefs directories.
569 #
570 echo "\n==== No $LABEL packages to build ====\n" \
571 >> $LOGFILE
572 fi
573 else
574 echo "\n==== Not creating $LABEL packages ====\n" >> $LOGFILE
575 fi
576
577 ROOT=$ORIGROOT
578 }
579
580 # Usage: dolint /dir y|n
581 # Arg. 2 is a flag to turn on/off the lint diff output
582 function dolint {
583 if [ ! -d "$1" ]; then
584 echo "dolint error: $1 is not a directory"
585 exit 1
586 fi
587
588 if [ "$2" != "y" -a "$2" != "n" ]; then
589 echo "dolint internal error: $2 should be 'y' or 'n'"
590 exit 1
591 fi
592
593 lintdir=$1
594 dodiff=$2
595 base=`basename $lintdir`
596 LINTOUT=$lintdir/lint-${MACH}.out
597 LINTNOISE=$lintdir/lint-noise-${MACH}
598 export ENVLDLIBS1=`myldlibs $ROOT`
599 export ENVCPPFLAGS1=`myheaders $ROOT`
600
601 set_debug_build_flags
602
603 #
604 # '$MAKE lint' in $lintdir
605 #
606 echo "\n==== Begin '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
607
608 # remove old lint.out
609 rm -f $lintdir/lint.out $lintdir/lint-noise.out
610 if [ -f $lintdir/lint-noise.ref ]; then
611 mv $lintdir/lint-noise.ref ${LINTNOISE}.ref
612 fi
613
614 rm -f $LINTOUT
615 cd $lintdir
616 #
617 # Remove all .ln files to ensure a full reference file
618 #
619 rm -f Nothing_to_remove \
620 `find . \( -name SCCS -o -name .hg -o -name .svn -o -name .git \) \
621 -prune -o -type f -name '*.ln' -print `
622
623 /bin/time $MAKE -ek lint 2>&1 | \
624 tee -a $LINTOUT >> $LOGFILE
625 echo "\n==== '$MAKE lint' of $base ERRORS ====\n" >> $mail_msg_file
626 grep "$MAKE:" $LINTOUT |
627 egrep -v "Ignoring unknown host" \
628 >> $mail_msg_file
629
630 echo "\n==== Ended '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
631
632 echo "\n==== Elapsed time of '$MAKE lint' of $base ====\n" \
633 >>$mail_msg_file
634 tail -3 $LINTOUT >>$mail_msg_file
635
636 rm -f ${LINTNOISE}.ref
637 if [ -f ${LINTNOISE}.out ]; then
638 mv ${LINTNOISE}.out ${LINTNOISE}.ref
639 fi
640 grep : $LINTOUT | \
641 egrep -v '^(real|user|sys)' |
642 egrep -v '(library construction)' | \
643 egrep -v ': global crosschecks' | \
644 egrep -v 'Ignoring unknown host' | \
645 egrep -v '\.c:$' | \
646 sort | uniq > ${LINTNOISE}.out
647 if [ ! -f ${LINTNOISE}.ref ]; then
648 cp ${LINTNOISE}.out ${LINTNOISE}.ref
649 fi
650 if [ "$dodiff" != "n" ]; then
651 echo "\n==== lint warnings $base ====\n" \
652 >>$mail_msg_file
653 # should be none, though there are a few that were filtered out
654 # above
655 egrep -i '(warning|lint):' ${LINTNOISE}.out \
656 | sort | uniq >> $mail_msg_file
657 echo "\n==== lint noise differences $base ====\n" \
658 >> $mail_msg_file
659 diff ${LINTNOISE}.ref ${LINTNOISE}.out \
660 >> $mail_msg_file
661 fi
662 }
663
664 # Install proto area from IHV build
665
666 function copy_ihv_proto {
667
668 echo "\n==== Installing IHV proto area ====\n" \
669 >> $LOGFILE
670 if [ -d "$IA32_IHV_ROOT" ]; then
671 if [ ! -d "$ROOT" ]; then
672 echo "mkdir -p $ROOT" >> $LOGFILE
673 mkdir -p $ROOT
674 fi
675 echo "copying $IA32_IHV_ROOT to $ROOT\n" >> $LOGFILE
676 cd $IA32_IHV_ROOT
677 tar cf - . | (cd $ROOT; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
678 else
679 echo "$IA32_IHV_ROOT: not found" >> $LOGFILE
680 fi
681
682 if [ "$MULTI_PROTO" = yes ]; then
683 if [ ! -d "$ROOT-nd" ]; then
684 echo "mkdir -p $ROOT-nd" >> $LOGFILE
685 mkdir -p $ROOT-nd
686 fi
687 # If there's a non-DEBUG version of the IHV proto area,
688 # copy it, but copy something if there's not.
689 if [ -d "$IA32_IHV_ROOT-nd" ]; then
690 echo "copying $IA32_IHV_ROOT-nd to $ROOT-nd\n" >> $LOGFILE
691 cd $IA32_IHV_ROOT-nd
692 elif [ -d "$IA32_IHV_ROOT" ]; then
693 echo "copying $IA32_IHV_ROOT to $ROOT-nd\n" >> $LOGFILE
694 cd $IA32_IHV_ROOT
695 else
696 echo "$IA32_IHV_ROOT{-nd,}: not found" >> $LOGFILE
697 return
698 fi
699 tar cf - . | (cd $ROOT-nd; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
700 fi
701 }
702
703 # Install IHV packages in PKGARCHIVE
704 # usage: copy_ihv_pkgs LABEL SUFFIX
705 function copy_ihv_pkgs {
706 LABEL=$1
707 SUFFIX=$2
708 # always use non-DEBUG IHV packages
709 IA32_IHV_PKGS=${IA32_IHV_PKGS_ORIG}-nd
710 PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
711
712 echo "\n==== Installing IHV packages from $IA32_IHV_PKGS ($LABEL) ====\n" \
713 >> $LOGFILE
714 if [ -d "$IA32_IHV_PKGS" ]; then
715 cd $IA32_IHV_PKGS
716 tar cf - * | \
717 (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
718 else
719 echo "$IA32_IHV_PKGS: not found" >> $LOGFILE
720 fi
721
722 echo "\n==== Installing IHV packages from $IA32_IHV_BINARY_PKGS ($LABEL) ====\n" \
723 >> $LOGFILE
724 if [ -d "$IA32_IHV_BINARY_PKGS" ]; then
725 cd $IA32_IHV_BINARY_PKGS
726 tar cf - * | \
727 (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
728 else
729 echo "$IA32_IHV_BINARY_PKGS: not found" >> $LOGFILE
730 fi
731 }
732
733 #
734 # Build and install the onbld tools.
735 #
736 # usage: build_tools DESTROOT
737 #
738 # returns non-zero status if the build was successful.
739 #
740 function build_tools {
741 DESTROOT=$1
742
743 INSTALLOG=install-${MACH}
744
745 echo "\n==== Building tools at `date` ====\n" \
746 >> $LOGFILE
747
748 rm -f ${TOOLS}/${INSTALLOG}.out
749 cd ${TOOLS}
750 /bin/time $MAKE TOOLS_PROTO=${DESTROOT} -e install 2>&1 | \
751 tee -a ${TOOLS}/${INSTALLOG}.out >> $LOGFILE
752
753 echo "\n==== Tools build errors ====\n" >> $mail_msg_file
754
755 egrep ":" ${TOOLS}/${INSTALLOG}.out |
756 egrep -e "(${MAKE}:|[ ]error[: \n])" | \
757 egrep -v "Ignoring unknown host" | \
758 egrep -v warning >> $mail_msg_file
759 return $?
760 }
761
762 #
763 # Set up to use locally installed tools.
764 #
765 # usage: use_tools TOOLSROOT
766 #
767 function use_tools {
768 TOOLSROOT=$1
769
770 #
771 # If we're not building ON workspace, then the TOOLSROOT
772 # settings here are clearly ignored by the workspace
773 # makefiles, prepending nonexistent directories to PATH is
774 # harmless, and we clearly do not wish to override
775 # ONBLD_TOOLS.
776 #
777 # If we're building an ON workspace, then the prepended PATH
778 # elements should supercede the preexisting ONBLD_TOOLS paths,
779 # and we want to override ONBLD_TOOLS to catch the tools that
780 # don't have specific path env vars here.
781 #
782 # So the only conditional behavior is overriding ONBLD_TOOLS,
783 # and we check for "an ON workspace" by looking for
784 # ${TOOLSROOT}/opt/onbld.
785 #
786
787 STABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/stabs
788 export STABS
789 CTFSTABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfstabs
790 export CTFSTABS
791 GENOFFSETS=${TOOLSROOT}/opt/onbld/bin/genoffsets
792 export GENOFFSETS
793
794 CTFCONVERT=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfconvert
795 export CTFCONVERT
796 CTFMERGE=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfmerge
797 export CTFMERGE
798
799 CTFCVTPTBL=${TOOLSROOT}/opt/onbld/bin/ctfcvtptbl
800 export CTFCVTPTBL
801 CTFFINDMOD=${TOOLSROOT}/opt/onbld/bin/ctffindmod
802 export CTFFINDMOD
803
804 if [ "$VERIFY_ELFSIGN" = "y" ]; then
805 ELFSIGN=${TOOLSROOT}/opt/onbld/bin/elfsigncmp
806 else
807 ELFSIGN=${TOOLSROOT}/opt/onbld/bin/${MACH}/elfsign
808 fi
809 export ELFSIGN
810
811 PATH="${TOOLSROOT}/opt/onbld/bin/${MACH}:${PATH}"
812 PATH="${TOOLSROOT}/opt/onbld/bin:${PATH}"
813 export PATH
814
815 if [ -d "${TOOLSROOT}/opt/onbld" ]; then
816 ONBLD_TOOLS=${TOOLSROOT}/opt/onbld
817 export ONBLD_TOOLS
818 fi
819
820 echo "\n==== New environment settings. ====\n" >> $LOGFILE
821 echo "STABS=${STABS}" >> $LOGFILE
822 echo "CTFSTABS=${CTFSTABS}" >> $LOGFILE
823 echo "CTFCONVERT=${CTFCONVERT}" >> $LOGFILE
824 echo "CTFMERGE=${CTFMERGE}" >> $LOGFILE
825 echo "CTFCVTPTBL=${CTFCVTPTBL}" >> $LOGFILE
826 echo "CTFFINDMOD=${CTFFINDMOD}" >> $LOGFILE
827 echo "ELFSIGN=${ELFSIGN}" >> $LOGFILE
828 echo "PATH=${PATH}" >> $LOGFILE
829 echo "ONBLD_TOOLS=${ONBLD_TOOLS}" >> $LOGFILE
830 }
831
832 function staffer {
833 if [ $ISUSER -ne 0 ]; then
834 "$@"
835 else
836 arg="\"$1\""
837 shift
838 for i
839 do
840 arg="$arg \"$i\""
841 done
842 eval su $STAFFER -c \'$arg\'
843 fi
844 }
845
846 #
847 # Verify that the closed tree is present if it needs to be.
848 #
849 function check_closed_tree {
850 if [[ ! -d "$ON_CLOSED_BINS" ]]; then
851 echo "ON_CLOSED_BINS must point to the closed binaries tree."
852 build_ok=n
853 exit 1
854 fi
855 }
856
857 function obsolete_build {
858 echo "WARNING: Obsolete $1 build requested; request will be ignored"
859 }
860
861 #
862 # wrapper over wsdiff.
863 # usage: do_wsdiff LABEL OLDPROTO NEWPROTO
864 #
865 function do_wsdiff {
866 label=$1
867 oldproto=$2
868 newproto=$3
869
870 wsdiff="wsdiff"
871 [ "$t_FLAG" = y ] && wsdiff="wsdiff -t"
872
873 echo "\n==== Getting object changes since last build at `date`" \
874 "($label) ====\n" | tee -a $LOGFILE >> $mail_msg_file
875 $wsdiff -s -r ${TMPDIR}/wsdiff.results $oldproto $newproto 2>&1 | \
876 tee -a $LOGFILE >> $mail_msg_file
877 echo "\n==== Object changes determined at `date` ($label) ====\n" | \
878 tee -a $LOGFILE >> $mail_msg_file
879 }
880
881 #
882 # Functions for setting build flags (DEBUG/non-DEBUG). Keep them
883 # together.
884 #
885
886 function set_non_debug_build_flags {
887 export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
888 export RELEASE_BUILD ; RELEASE_BUILD=
889 unset EXTRA_OPTIONS
890 unset EXTRA_CFLAGS
891 }
892
893 function set_debug_build_flags {
894 export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
895 unset RELEASE_BUILD
896 unset EXTRA_OPTIONS
897 unset EXTRA_CFLAGS
898 }
899
900
901 MACH=`uname -p`
902
903 if [ "$OPTHOME" = "" ]; then
904 OPTHOME=/opt
905 export OPTHOME
906 fi
907 if [ "$TEAMWARE" = "" ]; then
908 TEAMWARE=$OPTHOME/teamware
909 export TEAMWARE
910 fi
911
912 USAGE='Usage: nightly [-in] [+t] [-V VERS ] [ -S E|D|H|O ] <env_file>
913
914 Where:
915 -i Fast incremental options (no clobber, lint, check)
916 -n Do not do a bringover
917 +t Use the build tools in $ONBLD_TOOLS/bin
918 -V VERS set the build version string to VERS
919 -S Build a variant of the source product
920 E - build exportable source
921 D - build domestic source (exportable + crypt)
922 H - build hybrid source (binaries + deleted source)
923 O - build (only) open source
924
925 <env_file> file in Bourne shell syntax that sets and exports
926 variables that configure the operation of this script and many of
927 the scripts this one calls. If <env_file> does not exist,
928 it will be looked for in $OPTHOME/onbld/env.
929
930 non-DEBUG is the default build type. Build options can be set in the
931 NIGHTLY_OPTIONS variable in the <env_file> as follows:
932
933 -A check for ABI differences in .so files
934 -C check for cstyle/hdrchk errors
935 -D do a build with DEBUG on
936 -F do _not_ do a non-DEBUG build
937 -G gate keeper default group of options (-au)
938 -I integration engineer default group of options (-ampu)
939 -M do not run pmodes (safe file permission checker)
940 -N do not run protocmp
941 -O generate OpenSolaris deliverables
942 -R default group of options for building a release (-mp)
943 -U update proto area in the parent
944 -V VERS set the build version string to VERS
945 -X copy x86 IHV proto area
946 -f find unreferenced files
947 -i do an incremental build (no "make clobber")
948 -l do "make lint" in $LINTDIRS (default: $SRC y)
949 -m send mail to $MAILTO at end of build
950 -n do not do a bringover
951 -o build using root privileges to set OWNER/GROUP (old style)
952 -p create packages
953 -r check ELF runtime attributes in the proto area
954 -t build and use the tools in $SRC/tools (default setting)
955 +t Use the build tools in $ONBLD_TOOLS/bin
956 -u update proto_list_$MACH and friends in the parent workspace;
957 when used with -f, also build an unrefmaster.out in the parent
958 -w report on differences between previous and current proto areas
959 -z compress cpio archives with gzip
960 -W Do not report warnings (freeware gate ONLY)
961 -S Build a variant of the source product
962 E - build exportable source
963 D - build domestic source (exportable + crypt)
964 H - build hybrid source (binaries + deleted source)
965 O - build (only) open source
966 '
967 #
968 # A log file will be generated under the name $LOGFILE
969 # for partially completed build and log.`date '+%F'`
970 # in the same directory for fully completed builds.
971 #
972
973 # default values for low-level FLAGS; G I R are group FLAGS
974 A_FLAG=n
975 C_FLAG=n
976 D_FLAG=n
977 F_FLAG=n
978 f_FLAG=n
979 i_FLAG=n; i_CMD_LINE_FLAG=n
980 l_FLAG=n
981 M_FLAG=n
982 m_FLAG=n
983 N_FLAG=n
984 n_FLAG=n
985 O_FLAG=n
986 o_FLAG=n
987 P_FLAG=n
988 p_FLAG=n
989 r_FLAG=n
990 T_FLAG=n
991 t_FLAG=y
992 U_FLAG=n
993 u_FLAG=n
994 V_FLAG=n
995 W_FLAG=n
996 w_FLAG=n
997 X_FLAG=n
998 SD_FLAG=n
999 SE_FLAG=n
1000 SH_FLAG=n
1001 SO_FLAG=n
1002 #
1003 XMOD_OPT=
1004 #
1005 build_ok=y
1006
1007 function is_source_build {
1008 [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o \
1009 "$SH_FLAG" = "y" -o "$SO_FLAG" = "y" ]
1010 return $?
1011 }
1012
1013 #
1014 # examine arguments
1015 #
1016
1017 #
1018 # single function for setting -S flag and doing error checking.
1019 # usage: set_S_flag <type>
1020 # where <type> is the source build type ("E", "D", ...).
1021 #
1022 function set_S_flag {
1023 if is_source_build; then
1024 echo "Can only build one source variant at a time."
1025 exit 1
1026 fi
1027 if [ "$1" = "E" ]; then
1028 SE_FLAG=y
1029 elif [ "$1" = "D" ]; then
1030 SD_FLAG=y
1031 elif [ "$1" = "H" ]; then
1032 SH_FLAG=y
1033 elif [ "$1" = "O" ]; then
1034 SO_FLAG=y
1035 else
1036 echo "$USAGE"
1037 exit 1
1038 fi
1039 }
1040
1041 OPTIND=1
1042 while getopts +inS:tV: FLAG
1043 do
1044 case $FLAG in
1045 i ) i_FLAG=y; i_CMD_LINE_FLAG=y
1046 ;;
1047 n ) n_FLAG=y
1048 ;;
1049 S )
1050 set_S_flag $OPTARG
1051 ;;
1052 +t ) t_FLAG=n
1053 ;;
1054 V ) V_FLAG=y
1055 V_ARG="$OPTARG"
1056 ;;
1057 \? ) echo "$USAGE"
1058 exit 1
1059 ;;
1060 esac
1061 done
1062
1063 # correct argument count after options
1064 shift `expr $OPTIND - 1`
1065
1066 # test that the path to the environment-setting file was given
1067 if [ $# -ne 1 ]; then
1068 echo "$USAGE"
1069 exit 1
1070 fi
1071
1072 # check if user is running nightly as root
1073 # ISUSER is set non-zero if an ordinary user runs nightly, or is zero
1074 # when root invokes nightly.
1075 /usr/bin/id | grep '^uid=0(' >/dev/null 2>&1
1076 ISUSER=$?; export ISUSER
1077
1078 #
1079 # force locale to C
1080 LC_COLLATE=C; export LC_COLLATE
1081 LC_CTYPE=C; export LC_CTYPE
1082 LC_MESSAGES=C; export LC_MESSAGES
1083 LC_MONETARY=C; export LC_MONETARY
1084 LC_NUMERIC=C; export LC_NUMERIC
1085 LC_TIME=C; export LC_TIME
1086
1087 # clear environment variables we know to be bad for the build
1088 unset LD_OPTIONS
1089 unset LD_AUDIT LD_AUDIT_32 LD_AUDIT_64
1090 unset LD_BIND_NOW LD_BIND_NOW_32 LD_BIND_NOW_64
1091 unset LD_BREADTH LD_BREADTH_32 LD_BREADTH_64
1092 unset LD_CONFIG LD_CONFIG_32 LD_CONFIG_64
1093 unset LD_DEBUG LD_DEBUG_32 LD_DEBUG_64
1094 unset LD_DEMANGLE LD_DEMANGLE_32 LD_DEMANGLE_64
1095 unset LD_FLAGS LD_FLAGS_32 LD_FLAGS_64
1096 unset LD_LIBRARY_PATH LD_LIBRARY_PATH_32 LD_LIBRARY_PATH_64
1097 unset LD_LOADFLTR LD_LOADFLTR_32 LD_LOADFLTR_64
1098 unset LD_NOAUDIT LD_NOAUDIT_32 LD_NOAUDIT_64
1099 unset LD_NOAUXFLTR LD_NOAUXFLTR_32 LD_NOAUXFLTR_64
1100 unset LD_NOCONFIG LD_NOCONFIG_32 LD_NOCONFIG_64
1101 unset LD_NODIRCONFIG LD_NODIRCONFIG_32 LD_NODIRCONFIG_64
1102 unset LD_NODIRECT LD_NODIRECT_32 LD_NODIRECT_64
1103 unset LD_NOLAZYLOAD LD_NOLAZYLOAD_32 LD_NOLAZYLOAD_64
1104 unset LD_NOOBJALTER LD_NOOBJALTER_32 LD_NOOBJALTER_64
1105 unset LD_NOVERSION LD_NOVERSION_32 LD_NOVERSION_64
1106 unset LD_ORIGIN LD_ORIGIN_32 LD_ORIGIN_64
1107 unset LD_PRELOAD LD_PRELOAD_32 LD_PRELOAD_64
1108 unset LD_PROFILE LD_PROFILE_32 LD_PROFILE_64
1109
1110 unset CONFIG
1111 unset GROUP
1112 unset OWNER
1113 unset REMOTE
1114 unset ENV
1115 unset ARCH
1116 unset CLASSPATH
1117 unset NAME
1118
1119 #
1120 # To get ONBLD_TOOLS from the environment, it must come from the env file.
1121 # If it comes interactively, it is generally TOOLS_PROTO, which will be
1122 # clobbered before the compiler version checks, which will therefore fail.
1123 #
1124 unset ONBLD_TOOLS
1125
1126 #
1127 # Setup environmental variables
1128 #
1129 if [ -f /etc/nightly.conf ]; then
1130 . /etc/nightly.conf
1131 fi
1132
1133 if [ -f $1 ]; then
1134 if [[ $1 = */* ]]; then
1135 . $1
1136 else
1137 . ./$1
1138 fi
1139 else
1140 if [ -f $OPTHOME/onbld/env/$1 ]; then
1141 . $OPTHOME/onbld/env/$1
1142 else
1143 echo "Cannot find env file as either $1 or $OPTHOME/onbld/env/$1"
1144 exit 1
1145 fi
1146 fi
1147
1148 # contents of stdenv.sh inserted after next line:
1149 # STDENV_START
1150 # STDENV_END
1151
1152 # Check if we have sufficient data to continue...
1153 [[ -v CODEMGR_WS ]] || fatal_error "Error: Variable CODEMGR_WS not set."
1154 if [[ "${NIGHTLY_OPTIONS}" == ~(F)n ]] ; then
1155 # Check if the gate data are valid if we don't do a "bringover" below
1156 [[ -d "${CODEMGR_WS}" ]] || \
1157 fatal_error "Error: ${CODEMGR_WS} is not a directory."
1158 [[ -f "${CODEMGR_WS}/usr/src/Makefile" ]] || \
1159 fatal_error "Error: ${CODEMGR_WS}/usr/src/Makefile not found."
1160 fi
1161
1162 #
1163 # place ourselves in a new task, respecting BUILD_PROJECT if set.
1164 #
1165 if [ -z "$BUILD_PROJECT" ]; then
1166 /usr/bin/newtask -c $$
1167 else
1168 /usr/bin/newtask -c $$ -p $BUILD_PROJECT
1169 fi
1170
1171 ps -o taskid= -p $$ | read build_taskid
1172 ps -o project= -p $$ | read build_project
1173
1174 #
1175 # See if NIGHTLY_OPTIONS is set
1176 #
1177 if [ "$NIGHTLY_OPTIONS" = "" ]; then
1178 NIGHTLY_OPTIONS="-aBm"
1179 fi
1180
1181 #
1182 # If BRINGOVER_WS was not specified, let it default to CLONE_WS
1183 #
1184 if [ "$BRINGOVER_WS" = "" ]; then
1185 BRINGOVER_WS=$CLONE_WS
1186 fi
1187
1188 #
1189 # If CLOSED_BRINGOVER_WS was not specified, let it default to CLOSED_CLONE_WS
1190 #
1191 if [ "$CLOSED_BRINGOVER_WS" = "" ]; then
1192 CLOSED_BRINGOVER_WS=$CLOSED_CLONE_WS
1193 fi
1194
1195 #
1196 # If BRINGOVER_FILES was not specified, default to usr
1197 #
1198 if [ "$BRINGOVER_FILES" = "" ]; then
1199 BRINGOVER_FILES="usr"
1200 fi
1201
1202 check_closed_tree
1203
1204 #
1205 # Note: changes to the option letters here should also be applied to the
1206 # bldenv script. `d' is listed for backward compatibility.
1207 #
1208 NIGHTLY_OPTIONS=-${NIGHTLY_OPTIONS#-}
1209 OPTIND=1
1210 while getopts +ABCDdFfGIilMmNnOoPpRrS:TtUuWwXxz FLAG $NIGHTLY_OPTIONS
1211 do
1212 case $FLAG in
1213 A ) A_FLAG=y
1214 ;;
1215 B ) D_FLAG=y
1216 ;; # old version of D
1217 C ) C_FLAG=y
1218 ;;
1219 D ) D_FLAG=y
1220 ;;
1221 F ) F_FLAG=y
1222 ;;
1223 f ) f_FLAG=y
1224 ;;
1225 G ) u_FLAG=y
1226 ;;
1227 I ) m_FLAG=y
1228 p_FLAG=y
1229 u_FLAG=y
1230 ;;
1231 i ) i_FLAG=y
1232 ;;
1233 l ) l_FLAG=y
1234 ;;
1235 M ) M_FLAG=y
1236 ;;
1237 m ) m_FLAG=y
1238 ;;
1239 N ) N_FLAG=y
1240 ;;
1241 n ) n_FLAG=y
1242 ;;
1243 O ) O_FLAG=y
1244 ;;
1245 o ) o_FLAG=y
1246 ;;
1247 P ) P_FLAG=y
1248 ;; # obsolete
1249 p ) p_FLAG=y
1250 ;;
1251 R ) m_FLAG=y
1252 p_FLAG=y
1253 ;;
1254 r ) r_FLAG=y
1255 ;;
1256 S )
1257 set_S_flag $OPTARG
1258 ;;
1259 T ) T_FLAG=y
1260 ;; # obsolete
1261 +t ) t_FLAG=n
1262 ;;
1263 U ) if [ -z "${PARENT_ROOT}" ]; then
1264 echo "PARENT_ROOT must be set if the U flag is" \
1265 "present in NIGHTLY_OPTIONS."
1266 exit 1
1267 fi
1268 NIGHTLY_PARENT_ROOT=$PARENT_ROOT
1269 if [ -n "${PARENT_TOOLS_ROOT}" ]; then
1270 NIGHTLY_PARENT_TOOLS_ROOT=$PARENT_TOOLS_ROOT
1271 fi
1272 U_FLAG=y
1273 ;;
1274 u ) u_FLAG=y
1275 ;;
1276 W ) W_FLAG=y
1277 ;;
1278
1279 w ) w_FLAG=y
1280 ;;
1281 X ) # now that we no longer need realmode builds, just
1282 # copy IHV packages. only meaningful on x86.
1283 if [ "$MACH" = "i386" ]; then
1284 X_FLAG=y
1285 fi
1286 ;;
1287 x ) XMOD_OPT="-x"
1288 ;;
1289 \? ) echo "$USAGE"
1290 exit 1
1291 ;;
1292 esac
1293 done
1294
1295 if [ $ISUSER -ne 0 ]; then
1296 if [ "$o_FLAG" = "y" ]; then
1297 echo "Old-style build requires root permission."
1298 exit 1
1299 fi
1300
1301 # Set default value for STAFFER, if needed.
1302 if [ -z "$STAFFER" -o "$STAFFER" = "nobody" ]; then
1303 STAFFER=`/usr/xpg4/bin/id -un`
1304 export STAFFER
1305 fi
1306 fi
1307
1308 if [ -z "$MAILTO" -o "$MAILTO" = "nobody" ]; then
1309 MAILTO=$STAFFER
1310 export MAILTO
1311 fi
1312
1313 PATH="$OPTHOME/onbld/bin:$OPTHOME/onbld/bin/${MACH}:/usr/ccs/bin"
1314 PATH="$PATH:$OPTHOME/SUNWspro/bin:$TEAMWARE/bin:/usr/bin:/usr/sbin:/usr/ucb"
1315 PATH="$PATH:/usr/openwin/bin:/usr/sfw/bin:/opt/sfw/bin:."
1316 export PATH
1317
1318 # roots of source trees, both relative to $SRC and absolute.
1319 relsrcdirs="."
1320 abssrcdirs="$SRC"
1321
1322 unset CH
1323 if [ "$o_FLAG" = "y" ]; then
1324 # root invoked old-style build -- make sure it works as it always has
1325 # by exporting 'CH'. The current Makefile.master doesn't use this, but
1326 # the old ones still do.
1327 PROTOCMPTERSE="protocmp.terse"
1328 CH=
1329 export CH
1330 else
1331 PROTOCMPTERSE="protocmp.terse -gu"
1332 fi
1333 POUND_SIGN="#"
1334 # have we set RELEASE_DATE in our env file?
1335 if [ -z "$RELEASE_DATE" ]; then
1336 RELEASE_DATE=$(LC_ALL=C date +"%B %Y")
1337 fi
1338 BUILD_DATE=$(LC_ALL=C date +%Y-%b-%d)
1339 BASEWSDIR=$(basename $CODEMGR_WS)
1340 DEV_CM="\"@(#)SunOS Internal Development: $LOGNAME $BUILD_DATE [$BASEWSDIR]\""
1341
1342 # we export POUND_SIGN, RELEASE_DATE and DEV_CM to speed up the build process
1343 # by avoiding repeated shell invocations to evaluate Makefile.master definitions.
1344 # we export o_FLAG and X_FLAG for use by makebfu, and by usr/src/pkg/Makefile
1345 export o_FLAG X_FLAG POUND_SIGN RELEASE_DATE DEV_CM
1346
1347 maketype="distributed"
1348 MAKE=dmake
1349 # get the dmake version string alone
1350 DMAKE_VERSION=$( $MAKE -v )
1351 DMAKE_VERSION=${DMAKE_VERSION#*: }
1352 # focus in on just the dotted version number alone
1353 DMAKE_MAJOR=$( echo $DMAKE_VERSION | \
1354 sed -e 's/.*\<\([^.]*\.[^ ]*\).*$/\1/' )
1355 # extract the second (or final) integer
1356 DMAKE_MINOR=${DMAKE_MAJOR#*.}
1357 DMAKE_MINOR=${DMAKE_MINOR%%.*}
1358 # extract the first integer
1359 DMAKE_MAJOR=${DMAKE_MAJOR%%.*}
1360 CHECK_DMAKE=${CHECK_DMAKE:-y}
1361 # x86 was built on the 12th, sparc on the 13th.
1362 if [ "$CHECK_DMAKE" = "y" -a \
1363 "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/12" -a \
1364 "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/13" -a \( \
1365 "$DMAKE_MAJOR" -lt 7 -o \
1366 "$DMAKE_MAJOR" -eq 7 -a "$DMAKE_MINOR" -lt 4 \) ]; then
1367 if [ -z "$DMAKE_VERSION" ]; then
1368 echo "$MAKE is missing."
1369 exit 1
1370 fi
1371 echo `whence $MAKE`" version is:"
1372 echo " ${DMAKE_VERSION}"
1373 cat <<EOF
1374
1375 This version may not be safe for use. Either set TEAMWARE to a better
1376 path or (if you really want to use this version of dmake anyway), add
1377 the following to your environment to disable this check:
1378
1379 CHECK_DMAKE=n
1380 EOF
1381 exit 1
1382 fi
1383 export PATH
1384 export MAKE
1385
1386 if [[ "$O_FLAG" = y ]]; then
1387 export TONICBUILD=""
1388 else
1389 export TONICBUILD="#"
1390 fi
1391
1392 if [ "${SUNWSPRO}" != "" ]; then
1393 PATH="${SUNWSPRO}/bin:$PATH"
1394 export PATH
1395 fi
1396
1397 hostname=$(uname -n)
1398 if [[ $DMAKE_MAX_JOBS != +([0-9]) || $DMAKE_MAX_JOBS -eq 0 ]]
1399 then
1400 maxjobs=
1401 if [[ -f $HOME/.make.machines ]]
1402 then
1403 # Note: there is a hard tab and space character in the []s
1404 # below.
1405 egrep -i "^[ ]*$hostname[ \.]" \
1406 $HOME/.make.machines | read host jobs
1407 maxjobs=${jobs##*=}
1408 fi
1409
1410 if [[ $maxjobs != +([0-9]) || $maxjobs -eq 0 ]]
1411 then
1412 # default
1413 maxjobs=4
1414 fi
1415
1416 export DMAKE_MAX_JOBS=$maxjobs
1417 fi
1418
1419 DMAKE_MODE=parallel;
1420 export DMAKE_MODE
1421
1422 if [ -z "${ROOT}" ]; then
1423 echo "ROOT must be set."
1424 exit 1
1425 fi
1426
1427 #
1428 # if -V flag was given, reset VERSION to V_ARG
1429 #
1430 if [ "$V_FLAG" = "y" ]; then
1431 VERSION=$V_ARG
1432 fi
1433
1434 #
1435 # Check for IHV root for copying ihv proto area
1436 #
1437 if [ "$X_FLAG" = "y" ]; then
1438 if [ "$IA32_IHV_ROOT" = "" ]; then
1439 echo "IA32_IHV_ROOT: must be set for copying ihv proto"
1440 args_ok=n
1441 fi
1442 if [ ! -d "$IA32_IHV_ROOT" ]; then
1443 echo "$IA32_IHV_ROOT: not found"
1444 args_ok=n
1445 fi
1446 if [ "$IA32_IHV_WS" = "" ]; then
1447 echo "IA32_IHV_WS: must be set for copying ihv proto"
1448 args_ok=n
1449 fi
1450 if [ ! -d "$IA32_IHV_WS" ]; then
1451 echo "$IA32_IHV_WS: not found"
1452 args_ok=n
1453 fi
1454 fi
1455
1456 # Append source version
1457 if [ "$SE_FLAG" = "y" ]; then
1458 VERSION="${VERSION}:EXPORT"
1459 fi
1460
1461 if [ "$SD_FLAG" = "y" ]; then
1462 VERSION="${VERSION}:DOMESTIC"
1463 fi
1464
1465 if [ "$SH_FLAG" = "y" ]; then
1466 VERSION="${VERSION}:MODIFIED_SOURCE_PRODUCT"
1467 fi
1468
1469 if [ "$SO_FLAG" = "y" ]; then
1470 VERSION="${VERSION}:OPEN_ONLY"
1471 fi
1472
1473 TMPDIR="/tmp/nightly.tmpdir.$$"
1474 export TMPDIR
1475 rm -rf ${TMPDIR}
1476 mkdir -p $TMPDIR || exit 1
1477 chmod 777 $TMPDIR
1478
1479 #
1480 # Keep elfsign's use of pkcs11_softtoken from looking in the user home
1481 # directory, which doesn't always work. Needed until all build machines
1482 # have the fix for 6271754
1483 #
1484 SOFTTOKEN_DIR=$TMPDIR
1485 export SOFTTOKEN_DIR
1486
1487 #
1488 # Tools should only be built non-DEBUG. Keep track of the tools proto
1489 # area path relative to $TOOLS, because the latter changes in an
1490 # export build.
1491 #
1492 # TOOLS_PROTO is included below for builds other than usr/src/tools
1493 # that look for this location. For usr/src/tools, this will be
1494 # overridden on the $MAKE command line in build_tools().
1495 #
1496 TOOLS=${SRC}/tools
1497 TOOLS_PROTO_REL=proto/root_${MACH}-nd
1498 TOOLS_PROTO=${TOOLS}/${TOOLS_PROTO_REL}; export TOOLS_PROTO
1499
1500 unset CFLAGS LD_LIBRARY_PATH LDFLAGS
1501
1502 # create directories that are automatically removed if the nightly script
1503 # fails to start correctly
1504 function newdir {
1505 dir=$1
1506 toadd=
1507 while [ ! -d $dir ]; do
1508 toadd="$dir $toadd"
1509 dir=`dirname $dir`
1510 done
1511 torm=
1512 newlist=
1513 for dir in $toadd; do
1514 if staffer mkdir $dir; then
1515 newlist="$ISUSER $dir $newlist"
1516 torm="$dir $torm"
1517 else
1518 [ -z "$torm" ] || staffer rmdir $torm
1519 return 1
1520 fi
1521 done
1522 newdirlist="$newlist $newdirlist"
1523 return 0
1524 }
1525 newdirlist=
1526
1527 [ -d $CODEMGR_WS ] || newdir $CODEMGR_WS || exit 1
1528
1529 # since this script assumes the build is from full source, it nullifies
1530 # variables likely to have been set by a "ws" script; nullification
1531 # confines the search space for headers and libraries to the proto area
1532 # built from this immediate source.
1533 ENVLDLIBS1=
1534 ENVLDLIBS2=
1535 ENVLDLIBS3=
1536 ENVCPPFLAGS1=
1537 ENVCPPFLAGS2=
1538 ENVCPPFLAGS3=
1539 ENVCPPFLAGS4=
1540 PARENT_ROOT=
1541
1542 export ENVLDLIBS3 ENVCPPFLAGS1 ENVCPPFLAGS2 ENVCPPFLAGS3 ENVCPPFLAGS4 \
1543 PARENT_ROOT
1544
1545 PKGARCHIVE_ORIG=$PKGARCHIVE
1546 IA32_IHV_PKGS_ORIG=$IA32_IHV_PKGS
1547
1548 #
1549 # Juggle the logs and optionally send mail on completion.
1550 #
1551
1552 function logshuffle {
1553 LLOG="$ATLOG/log.`date '+%F.%H:%M'`"
1554 if [ -f $LLOG -o -d $LLOG ]; then
1555 LLOG=$LLOG.$$
1556 fi
1557 mkdir $LLOG
1558 export LLOG
1559
1560 if [ "$build_ok" = "y" ]; then
1561 mv $ATLOG/proto_list_${MACH} $LLOG
1562
1563 if [ -f $ATLOG/proto_list_tools_${MACH} ]; then
1564 mv $ATLOG/proto_list_tools_${MACH} $LLOG
1565 fi
1566
1567 if [ -f $TMPDIR/wsdiff.results ]; then
1568 mv $TMPDIR/wsdiff.results $LLOG
1569 fi
1570
1571 if [ -f $TMPDIR/wsdiff-nd.results ]; then
1572 mv $TMPDIR/wsdiff-nd.results $LLOG
1573 fi
1574 fi
1575
1576 #
1577 # Now that we're about to send mail, it's time to check the noise
1578 # file. In the event that an error occurs beyond this point, it will
1579 # be recorded in the nightly.log file, but nowhere else. This would
1580 # include only errors that cause the copying of the noise log to fail
1581 # or the mail itself not to be sent.
1582 #
1583
1584 exec >>$LOGFILE 2>&1
1585 if [ -s $build_noise_file ]; then
1586 echo "\n==== Nightly build noise ====\n" |
1587 tee -a $LOGFILE >>$mail_msg_file
1588 cat $build_noise_file >>$LOGFILE
1589 cat $build_noise_file >>$mail_msg_file
1590 echo | tee -a $LOGFILE >>$mail_msg_file
1591 fi
1592 rm -f $build_noise_file
1593
1594 case "$build_ok" in
1595 y)
1596 state=Completed
1597 ;;
1598 i)
1599 state=Interrupted
1600 ;;
1601 *)
1602 state=Failed
1603 ;;
1604 esac
1605 NIGHTLY_STATUS=$state
1606 export NIGHTLY_STATUS
1607
1608 run_hook POST_NIGHTLY $state
1609 run_hook SYS_POST_NIGHTLY $state
1610
1611 #
1612 # mailx(1) sets From: based on the -r flag
1613 # if it is given.
1614 #
1615 mailx_r=
1616 if [[ -n "${MAILFROM}" ]]; then
1617 mailx_r="-r ${MAILFROM}"
1618 fi
1619
1620 cat $build_time_file $build_environ_file $mail_msg_file \
1621 > ${LLOG}/mail_msg
1622 if [ "$m_FLAG" = "y" ]; then
1623 cat ${LLOG}/mail_msg | /usr/bin/mailx ${mailx_r} -s \
1624 "Nightly ${MACH} Build of `basename ${CODEMGR_WS}` ${state}." \
1625 ${MAILTO}
1626 fi
1627
1628 if [ "$u_FLAG" = "y" -a "$build_ok" = "y" ]; then
1629 staffer cp ${LLOG}/mail_msg $PARENT_WS/usr/src/mail_msg-${MACH}
1630 staffer cp $LOGFILE $PARENT_WS/usr/src/nightly-${MACH}.log
1631 fi
1632
1633 mv $LOGFILE $LLOG
1634 }
1635
1636 #
1637 # Remove the locks and temporary files on any exit
1638 #
1639 function cleanup {
1640 logshuffle
1641
1642 [ -z "$lockfile" ] || staffer rm -f $lockfile
1643 [ -z "$atloglockfile" ] || rm -f $atloglockfile
1644 [ -z "$ulockfile" ] || staffer rm -f $ulockfile
1645 [ -z "$Ulockfile" ] || rm -f $Ulockfile
1646
1647 set -- $newdirlist
1648 while [ $# -gt 0 ]; do
1649 ISUSER=$1 staffer rmdir $2
1650 shift; shift
1651 done
1652 rm -rf $TMPDIR
1653 }
1654
1655 function cleanup_signal {
1656 build_ok=i
1657 # this will trigger cleanup(), above.
1658 exit 1
1659 }
1660
1661 trap cleanup 0
1662 trap cleanup_signal 1 2 3 15
1663
1664 #
1665 # Generic lock file processing -- make sure that the lock file doesn't
1666 # exist. If it does, it should name the build host and PID. If it
1667 # doesn't, then make sure we can create it. Clean up locks that are
1668 # known to be stale (assumes host name is unique among build systems
1669 # for the workspace).
1670 #
1671 function create_lock {
1672 lockf=$1
1673 lockvar=$2
1674
1675 ldir=`dirname $lockf`
1676 [ -d $ldir ] || newdir $ldir || exit 1
1677 eval $lockvar=$lockf
1678
1679 while ! staffer ln -s $hostname.$STAFFER.$$ $lockf 2> /dev/null; do
1680 basews=`basename $CODEMGR_WS`
1681 ls -l $lockf | nawk '{print $NF}' | IFS=. read host user pid
1682 if [ "$host" != "$hostname" ]; then
1683 echo "$MACH build of $basews apparently" \
1684 "already started by $user on $host as $pid."
1685 exit 1
1686 elif kill -s 0 $pid 2>/dev/null; then
1687 echo "$MACH build of $basews already started" \
1688 "by $user as $pid."
1689 exit 1
1690 else
1691 # stale lock; clear it out and try again
1692 rm -f $lockf
1693 fi
1694 done
1695 }
1696
1697 #
1698 # Return the list of interesting proto areas, depending on the current
1699 # options.
1700 #
1701 function allprotos {
1702 typeset roots="$ROOT"
1703
1704 if [[ "$F_FLAG" = n && "$MULTI_PROTO" = yes ]]; then
1705 roots="$roots $ROOT-nd"
1706 fi
1707
1708 if [[ $O_FLAG = y ]]; then
1709 roots="$roots $ROOT-closed"
1710 [ $MULTI_PROTO = yes ] && roots="$roots $ROOT-nd-closed"
1711 fi
1712
1713 echo $roots
1714 }
1715
1716 # Ensure no other instance of this script is running on this host.
1717 # LOCKNAME can be set in <env_file>, and is by default, but is not
1718 # required due to the use of $ATLOG below.
1719 if [ -n "$LOCKNAME" ]; then
1720 create_lock /tmp/$LOCKNAME "lockfile"
1721 fi
1722 #
1723 # Create from one, two, or three other locks:
1724 # $ATLOG/nightly.lock
1725 # - protects against multiple builds in same workspace
1726 # $PARENT_WS/usr/src/nightly.$MACH.lock
1727 # - protects against multiple 'u' copy-backs
1728 # $NIGHTLY_PARENT_ROOT/nightly.lock
1729 # - protects against multiple 'U' copy-backs
1730 #
1731 # Overriding ISUSER to 1 causes the lock to be created as root if the
1732 # script is run as root. The default is to create it as $STAFFER.
1733 ISUSER=1 create_lock $ATLOG/nightly.lock "atloglockfile"
1734 if [ "$u_FLAG" = "y" ]; then
1735 create_lock $PARENT_WS/usr/src/nightly.$MACH.lock "ulockfile"
1736 fi
1737 if [ "$U_FLAG" = "y" ]; then
1738 # NIGHTLY_PARENT_ROOT is written as root if script invoked as root.
1739 ISUSER=1 create_lock $NIGHTLY_PARENT_ROOT/nightly.lock "Ulockfile"
1740 fi
1741
1742 # Locks have been taken, so we're doing a build and we're committed to
1743 # the directories we may have created so far.
1744 newdirlist=
1745
1746 #
1747 # Create mail_msg_file
1748 #
1749 mail_msg_file="${TMPDIR}/mail_msg"
1750 touch $mail_msg_file
1751 build_time_file="${TMPDIR}/build_time"
1752 build_environ_file="${TMPDIR}/build_environ"
1753 touch $build_environ_file
1754 #
1755 # Move old LOGFILE aside
1756 # ATLOG directory already made by 'create_lock' above
1757 #
1758 if [ -f $LOGFILE ]; then
1759 mv -f $LOGFILE ${LOGFILE}-
1760 fi
1761 #
1762 # Build OsNet source
1763 #
1764 START_DATE=`date`
1765 SECONDS=0
1766 echo "\n==== Nightly $maketype build started: $START_DATE ====" \
1767 | tee -a $LOGFILE > $build_time_file
1768
1769 echo "\nBuild project: $build_project\nBuild taskid: $build_taskid" | \
1770 tee -a $mail_msg_file >> $LOGFILE
1771
1772 # make sure we log only to the nightly build file
1773 build_noise_file="${TMPDIR}/build_noise"
1774 exec </dev/null >$build_noise_file 2>&1
1775
1776 run_hook SYS_PRE_NIGHTLY
1777 run_hook PRE_NIGHTLY
1778
1779 echo "\n==== list of environment variables ====\n" >> $LOGFILE
1780 env >> $LOGFILE
1781
1782 echo "\n==== Nightly argument issues ====\n" | tee -a $mail_msg_file >> $LOGFILE
1783
1784 if [ "$P_FLAG" = "y" ]; then
1785 obsolete_build GPROF | tee -a $mail_msg_file >> $LOGFILE
1786 fi
1787
1788 if [ "$T_FLAG" = "y" ]; then
1789 obsolete_build TRACE | tee -a $mail_msg_file >> $LOGFILE
1790 fi
1791
1792 if is_source_build; then
1793 if [ "$i_FLAG" = "y" -o "$i_CMD_LINE_FLAG" = "y" ]; then
1794 echo "WARNING: the -S flags do not support incremental" \
1795 "builds; forcing clobber\n" | tee -a $mail_msg_file >> $LOGFILE
1796 i_FLAG=n
1797 i_CMD_LINE_FLAG=n
1798 fi
1799 if [ "$N_FLAG" = "n" ]; then
1800 echo "WARNING: the -S flags do not support protocmp;" \
1801 "protocmp disabled\n" | \
1802 tee -a $mail_msg_file >> $LOGFILE
1803 N_FLAG=y
1804 fi
1805 if [ "$l_FLAG" = "y" ]; then
1806 echo "WARNING: the -S flags do not support lint;" \
1807 "lint disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1808 l_FLAG=n
1809 fi
1810 if [ "$C_FLAG" = "y" ]; then
1811 echo "WARNING: the -S flags do not support cstyle;" \
1812 "cstyle check disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1813 C_FLAG=n
1814 fi
1815 else
1816 if [ "$N_FLAG" = "y" ]; then
1817 if [ "$p_FLAG" = "y" ]; then
1818 cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1819 WARNING: the p option (create packages) is set, but so is the N option (do
1820 not run protocmp); this is dangerous; you should unset the N option
1821 EOF
1822 else
1823 cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1824 Warning: the N option (do not run protocmp) is set; it probably shouldn't be
1825 EOF
1826 fi
1827 echo "" | tee -a $mail_msg_file >> $LOGFILE
1828 fi
1829 fi
1830
1831 if [ "$D_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
1832 #
1833 # In the past we just complained but went ahead with the lint
1834 # pass, even though the proto area was built non-DEBUG. It's
1835 # unlikely that non-DEBUG headers will make a difference, but
1836 # rather than assuming it's a safe combination, force the user
1837 # to specify a DEBUG build.
1838 #
1839 echo "WARNING: DEBUG build not requested; disabling lint.\n" \
1840 | tee -a $mail_msg_file >> $LOGFILE
1841 l_FLAG=n
1842 fi
1843
1844 if [ "$f_FLAG" = "y" ]; then
1845 if [ "$i_FLAG" = "y" ]; then
1846 echo "WARNING: the -f flag cannot be used during incremental" \
1847 "builds; ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1848 f_FLAG=n
1849 fi
1850 if [ "${l_FLAG}${p_FLAG}" != "yy" ]; then
1851 echo "WARNING: the -f flag requires -l, and -p;" \
1852 "ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1853 f_FLAG=n
1854 fi
1855 fi
1856
1857 if [ "$w_FLAG" = "y" -a ! -d $ROOT ]; then
1858 echo "WARNING: -w specified, but $ROOT does not exist;" \
1859 "ignoring -w\n" | tee -a $mail_msg_file >> $LOGFILE
1860 w_FLAG=n
1861 fi
1862
1863 if [ "$t_FLAG" = "n" ]; then
1864 #
1865 # We're not doing a tools build, so make sure elfsign(1) is
1866 # new enough to safely sign non-crypto binaries. We test
1867 # debugging output from elfsign to detect the old version.
1868 #
1869 newelfsigntest=`SUNW_CRYPTO_DEBUG=stderr /usr/bin/elfsign verify \
1870 -e /usr/lib/security/pkcs11_softtoken.so.1 2>&1 \
1871 | egrep algorithmOID`
1872 if [ -z "$newelfsigntest" ]; then
1873 echo "WARNING: /usr/bin/elfsign out of date;" \
1874 "will only sign crypto modules\n" | \
1875 tee -a $mail_msg_file >> $LOGFILE
1876 export ELFSIGN_OBJECT=true
1877 elif [ "$VERIFY_ELFSIGN" = "y" ]; then
1878 echo "WARNING: VERIFY_ELFSIGN=y requires" \
1879 "the -t flag; ignoring VERIFY_ELFSIGN\n" | \
1880 tee -a $mail_msg_file >> $LOGFILE
1881 fi
1882 fi
1883
1884 [ "$O_FLAG" = y ] && MULTI_PROTO=yes
1885
1886 case $MULTI_PROTO in
1887 yes|no) ;;
1888 *)
1889 echo "WARNING: MULTI_PROTO is \"$MULTI_PROTO\"; " \
1890 "should be \"yes\" or \"no\"." | tee -a $mail_msg_file >> $LOGFILE
1891 echo "Setting MULTI_PROTO to \"no\".\n" | \
1892 tee -a $mail_msg_file >> $LOGFILE
1893 export MULTI_PROTO=no
1894 ;;
1895 esac
1896
1897 echo "\n==== Build version ====\n" | tee -a $mail_msg_file >> $LOGFILE
1898 echo $VERSION | tee -a $mail_msg_file >> $LOGFILE
1899
1900 # Save the current proto area if we're comparing against the last build
1901 if [ "$w_FLAG" = "y" -a -d "$ROOT" ]; then
1902 if [ -d "$ROOT.prev" ]; then
1903 rm -rf $ROOT.prev
1904 fi
1905 mv $ROOT $ROOT.prev
1906 fi
1907
1908 # Same for non-DEBUG proto area
1909 if [ "$w_FLAG" = "y" -a "$MULTI_PROTO" = yes -a -d "$ROOT-nd" ]; then
1910 if [ -d "$ROOT-nd.prev" ]; then
1911 rm -rf $ROOT-nd.prev
1912 fi
1913 mv $ROOT-nd $ROOT-nd.prev
1914 fi
1915
1916 #
1917 # Echo the SCM type of the parent workspace, this can't just be which_scm
1918 # as that does not know how to identify various network repositories.
1919 #
1920 function parent_wstype {
1921 typeset scm_type junk
1922
1923 CODEMGR_WS="$BRINGOVER_WS" "$WHICH_SCM" 2>/dev/null \
1924 | read scm_type junk
1925 if [[ -z "$scm_type" || "$scm_type" == unknown ]]; then
1926 # Probe BRINGOVER_WS to determine its type
1927 if [[ $BRINGOVER_WS == svn*://* ]]; then
1928 scm_type="subversion"
1929 elif [[ $BRINGOVER_WS == file://* ]] &&
1930 egrep -s "This is a Subversion repository" \
1931 ${BRINGOVER_WS#file://}/README.txt 2> /dev/null; then
1932 scm_type="subversion"
1933 elif [[ $BRINGOVER_WS == ssh://* ]]; then
1934 scm_type="mercurial"
1935 elif [[ $BRINGOVER_WS == http://* ]] && \
1936 wget -q -O- --save-headers "$BRINGOVER_WS/?cmd=heads" | \
1937 egrep -s "application/mercurial" 2> /dev/null; then
1938 scm_type="mercurial"
1939 elif svn info $BRINGOVER_WS > /dev/null 2>&1; then
1940 scm_type="subversion"
1941 else
1942 scm_type="none"
1943 fi
1944 fi
1945
1946 # fold both unsupported and unrecognized results into "none"
1947 case "$scm_type" in
1948 none|subversion|teamware|mercurial)
1949 ;;
1950 *) scm_type=none
1951 ;;
1952 esac
1953
1954 echo $scm_type
1955 }
1956
1957 # Echo the SCM types of $CODEMGR_WS and $BRINGOVER_WS
1958 function child_wstype {
1959 typeset scm_type junk
1960
1961 # Probe CODEMGR_WS to determine its type
1962 if [[ -d $CODEMGR_WS ]]; then
1963 $WHICH_SCM | read scm_type junk || exit 1
1964 fi
1965
1966 case "$scm_type" in
1967 none|subversion|git|teamware|mercurial)
1968 ;;
1969 *) scm_type=none
1970 ;;
1971 esac
1972
1973 echo $scm_type
1974 }
1975
1976 SCM_TYPE=$(child_wstype)
1977
1978 #
1979 # Decide whether to clobber
1980 #
1981 if [ "$i_FLAG" = "n" -a -d "$SRC" ]; then
1982 echo "\n==== Make clobber at `date` ====\n" >> $LOGFILE
1983
1984 cd $SRC
1985 # remove old clobber file
1986 rm -f $SRC/clobber.out
1987 rm -f $SRC/clobber-${MACH}.out
1988
1989 # Remove all .make.state* files, just in case we are restarting
1990 # the build after having interrupted a previous 'make clobber'.
1991 find . \( -name SCCS -o -name .hg -o -name .svn -o -name .git \
1992 -o -name 'interfaces.*' \) -prune \
1993 -o -name '.make.*' -print | xargs rm -f
1994
1995 $MAKE -ek clobber 2>&1 | tee -a $SRC/clobber-${MACH}.out >> $LOGFILE
1996 echo "\n==== Make clobber ERRORS ====\n" >> $mail_msg_file
1997 grep "$MAKE:" $SRC/clobber-${MACH}.out |
1998 egrep -v "Ignoring unknown host" \
1999 >> $mail_msg_file
2000
2001 if [[ "$t_FLAG" = "y" || "$O_FLAG" = "y" ]]; then
2002 echo "\n==== Make tools clobber at `date` ====\n" >> $LOGFILE
2003 cd ${TOOLS}
2004 rm -f ${TOOLS}/clobber-${MACH}.out
2005 $MAKE TOOLS_PROTO=$TOOLS_PROTO -ek clobber 2>&1 | \
2006 tee -a ${TOOLS}/clobber-${MACH}.out >> $LOGFILE
2007 echo "\n==== Make tools clobber ERRORS ====\n" \
2008 >> $mail_msg_file
2009 grep "$MAKE:" ${TOOLS}/clobber-${MACH}.out \
2010 >> $mail_msg_file
2011 rm -rf ${TOOLS_PROTO}
2012 mkdir -p ${TOOLS_PROTO}
2013 fi
2014
2015 typeset roots=$(allprotos)
2016 echo "\n\nClearing $roots" >> "$LOGFILE"
2017 rm -rf $roots
2018
2019 # Get back to a clean workspace as much as possible to catch
2020 # problems that only occur on fresh workspaces.
2021 # Remove all .make.state* files, libraries, and .o's that may
2022 # have been omitted from clobber. A couple of libraries are
2023 # under source code control, so leave them alone.
2024 # We should probably blow away temporary directories too.
2025 cd $SRC
2026 find $relsrcdirs \( -name SCCS -o -name .hg -o -name .svn \
2027 -o -name .git -o -name 'interfaces.*' \) -prune -o \
2028 \( -name '.make.*' -o -name 'lib*.a' -o -name 'lib*.so*' -o \
2029 -name '*.o' \) -print | \
2030 grep -v 'tools/ctf/dwarf/.*/libdwarf' | xargs rm -f
2031 else
2032 echo "\n==== No clobber at `date` ====\n" >> $LOGFILE
2033 fi
2034
2035 type bringover_teamware > /dev/null 2>&1 || function bringover_teamware {
2036 # sleep on the parent workspace's lock
2037 while egrep -s write $BRINGOVER_WS/Codemgr_wsdata/locks
2038 do
2039 sleep 120
2040 done
2041
2042 if [[ -z $BRINGOVER ]]; then
2043 BRINGOVER=$TEAMWARE/bin/bringover
2044 fi
2045
2046 staffer $BRINGOVER -c "nightly update" -p $BRINGOVER_WS \
2047 -w $CODEMGR_WS $BRINGOVER_FILES < /dev/null 2>&1 ||
2048 touch $TMPDIR/bringover_failed
2049
2050 staffer bringovercheck $CODEMGR_WS >$TMPDIR/bringovercheck.out 2>&1
2051 if [ -s $TMPDIR/bringovercheck.out ]; then
2052 echo "\n==== POST-BRINGOVER CLEANUP NOISE ====\n"
2053 cat $TMPDIR/bringovercheck.out
2054 fi
2055 }
2056
2057 type bringover_mercurial > /dev/null 2>&1 || function bringover_mercurial {
2058 typeset -x PATH=$PATH
2059
2060 # If the repository doesn't exist yet, then we want to populate it.
2061 if [[ ! -d $CODEMGR_WS/.hg ]]; then
2062 staffer hg init $CODEMGR_WS
2063 staffer echo "[paths]" > $CODEMGR_WS/.hg/hgrc
2064 staffer echo "default=$BRINGOVER_WS" >> $CODEMGR_WS/.hg/hgrc
2065 touch $TMPDIR/new_repository
2066 fi
2067
2068 typeset -x HGMERGE="/bin/false"
2069
2070 #
2071 # If the user has changes, regardless of whether those changes are
2072 # committed, and regardless of whether those changes conflict, then
2073 # we'll attempt to merge them either implicitly (uncommitted) or
2074 # explicitly (committed).
2075 #
2076 # These are the messages we'll use to help clarify mercurial output
2077 # in those cases.
2078 #
2079 typeset mergefailmsg="\
2080 ***\n\
2081 *** nightly was unable to automatically merge your changes. You should\n\
2082 *** redo the full merge manually, following the steps outlined by mercurial\n\
2083 *** above, then restart nightly.\n\
2084 ***\n"
2085 typeset mergepassmsg="\
2086 ***\n\
2087 *** nightly successfully merged your changes. This means that your working\n\
2088 *** directory has been updated, but those changes are not yet committed.\n\
2089 *** After nightly completes, you should validate the results of the merge,\n\
2090 *** then use hg commit manually.\n\
2091 ***\n"
2092
2093 #
2094 # For each repository in turn:
2095 #
2096 # 1. Do the pull. If this fails, dump the output and bail out.
2097 #
2098 # 2. If the pull resulted in an extra head, do an explicit merge.
2099 # If this fails, dump the output and bail out.
2100 #
2101 # Because we can't rely on Mercurial to exit with a failure code
2102 # when a merge fails (Mercurial issue #186), we must grep the
2103 # output of pull/merge to check for attempted and/or failed merges.
2104 #
2105 # 3. If a merge failed, set the message and fail the bringover.
2106 #
2107 # 4. Otherwise, if a merge succeeded, set the message
2108 #
2109 # 5. Dump the output, and any message from step 3 or 4.
2110 #
2111
2112 typeset HG_SOURCE=$BRINGOVER_WS
2113 if [ ! -f $TMPDIR/new_repository ]; then
2114 HG_SOURCE=$TMPDIR/open_bundle.hg
2115 staffer hg --cwd $CODEMGR_WS incoming --bundle $HG_SOURCE \
2116 -v $BRINGOVER_WS > $TMPDIR/incoming_open.out
2117
2118 #
2119 # If there are no incoming changesets, then incoming will
2120 # fail, and there will be no bundle file. Reset the source,
2121 # to allow the remaining logic to complete with no false
2122 # negatives. (Unlike incoming, pull will return success
2123 # for the no-change case.)
2124 #
2125 if (( $? != 0 )); then
2126 HG_SOURCE=$BRINGOVER_WS
2127 fi
2128 fi
2129
2130 staffer hg --cwd $CODEMGR_WS pull -u $HG_SOURCE \
2131 > $TMPDIR/pull_open.out 2>&1
2132 if (( $? != 0 )); then
2133 printf "%s: pull failed as follows:\n\n" "$CODEMGR_WS"
2134 cat $TMPDIR/pull_open.out
2135 if grep "^merging.*failed" $TMPDIR/pull_open.out > /dev/null 2>&1; then
2136 printf "$mergefailmsg"
2137 fi
2138 touch $TMPDIR/bringover_failed
2139 return
2140 fi
2141
2142 if grep "not updating" $TMPDIR/pull_open.out > /dev/null 2>&1; then
2143 staffer hg --cwd $CODEMGR_WS merge \
2144 >> $TMPDIR/pull_open.out 2>&1
2145 if (( $? != 0 )); then
2146 printf "%s: merge failed as follows:\n\n" \
2147 "$CODEMGR_WS"
2148 cat $TMPDIR/pull_open.out
2149 if grep "^merging.*failed" $TMPDIR/pull_open.out \
2150 > /dev/null 2>&1; then
2151 printf "$mergefailmsg"
2152 fi
2153 touch $TMPDIR/bringover_failed
2154 return
2155 fi
2156 fi
2157
2158 printf "updated %s with the following results:\n" "$CODEMGR_WS"
2159 cat $TMPDIR/pull_open.out
2160 if grep "^merging" $TMPDIR/pull_open.out >/dev/null 2>&1; then
2161 printf "$mergepassmsg"
2162 fi
2163 printf "\n"
2164
2165 #
2166 # Per-changeset output is neither useful nor manageable for a
2167 # newly-created repository.
2168 #
2169 if [ -f $TMPDIR/new_repository ]; then
2170 return
2171 fi
2172
2173 printf "\nadded the following changesets to open repository:\n"
2174 cat $TMPDIR/incoming_open.out
2175
2176 #
2177 # The closed repository could have been newly created, even though
2178 # the open one previously existed...
2179 #
2180 if [ -f $TMPDIR/new_closed ]; then
2181 return
2182 fi
2183
2184 if [ -f $TMPDIR/incoming_closed.out ]; then
2185 printf "\nadded the following changesets to closed repository:\n"
2186 cat $TMPDIR/incoming_closed.out
2187 fi
2188 }
2189
2190 type bringover_subversion > /dev/null 2>&1 || function bringover_subversion {
2191 typeset -x PATH=$PATH
2192
2193 if [[ ! -d $CODEMGR_WS/.svn ]]; then
2194 staffer svn checkout $BRINGOVER_WS $CODEMGR_WS ||
2195 touch $TMPDIR/bringover_failed
2196 else
2197 typeset root
2198 root=$(staffer svn info $CODEMGR_WS |
2199 nawk '/^Repository Root:/ {print $NF}')
2200 if [[ $root != $BRINGOVER_WS ]]; then
2201 # We fail here because there's no way to update
2202 # from a named repo.
2203 cat <<-EOF
2204 \$BRINGOVER_WS doesn't match repository root:
2205 \$BRINGOVER_WS: $BRINGOVER_WS
2206 Repository root: $root
2207 EOF
2208 touch $TMPDIR/bringover_failed
2209 else
2210 # If a conflict happens, svn still exits 0.
2211 staffer svn update $CODEMGR_WS | tee $TMPDIR/pull.out ||
2212 touch $TMPDIR/bringover_failed
2213 if grep "^C" $TMPDIR/pull.out > /dev/null 2>&1; then
2214 touch $TMPDIR/bringover_failed
2215 fi
2216 fi
2217 fi
2218 }
2219
2220 type bringover_none > /dev/null 2>&1 || function bringover_none {
2221 echo "Couldn't figure out what kind of SCM to use for $BRINGOVER_WS."
2222 touch $TMPDIR/bringover_failed
2223 }
2224
2225 #
2226 # Decide whether to bringover to the codemgr workspace
2227 #
2228 if [ "$n_FLAG" = "n" ]; then
2229 PARENT_SCM_TYPE=$(parent_wstype)
2230
2231 if [[ $SCM_TYPE != none && $SCM_TYPE != $PARENT_SCM_TYPE ]]; then
2232 echo "cannot bringover from $PARENT_SCM_TYPE to $SCM_TYPE, " \
2233 "quitting at `date`." | tee -a $mail_msg_file >> $LOGFILE
2234 exit 1
2235 fi
2236
2237 run_hook PRE_BRINGOVER
2238
2239 echo "\n==== bringover to $CODEMGR_WS at `date` ====\n" >> $LOGFILE
2240 echo "\n==== BRINGOVER LOG ====\n" >> $mail_msg_file
2241
2242 eval "bringover_${PARENT_SCM_TYPE}" 2>&1 |
2243 tee -a $mail_msg_file >> $LOGFILE
2244
2245 if [ -f $TMPDIR/bringover_failed ]; then
2246 rm -f $TMPDIR/bringover_failed
2247 build_ok=n
2248 echo "trouble with bringover, quitting at `date`." |
2249 tee -a $mail_msg_file >> $LOGFILE
2250 exit 1
2251 fi
2252
2253 #
2254 # It's possible that we used the bringover above to create
2255 # $CODEMGR_WS. If so, then SCM_TYPE was previously "none,"
2256 # but should now be the same as $BRINGOVER_WS.
2257 #
2258 [[ $SCM_TYPE = none ]] && SCM_TYPE=$PARENT_SCM_TYPE
2259
2260 run_hook POST_BRINGOVER
2261
2262 check_closed_tree
2263
2264 else
2265 echo "\n==== No bringover to $CODEMGR_WS ====\n" >> $LOGFILE
2266 fi
2267
2268 if [[ "$O_FLAG" = y ]]; then
2269 build_ok=n
2270 echo "OpenSolaris binary deliverables need usr/closed." \
2271 | tee -a "$mail_msg_file" >> $LOGFILE
2272 exit 1
2273 fi
2274
2275 # Safeguards
2276 [[ -v CODEMGR_WS ]] || fatal_error "Error: Variable CODEMGR_WS not set."
2277 [[ -d "${CODEMGR_WS}" ]] || fatal_error "Error: ${CODEMGR_WS} is not a directory."
2278 [[ -f "${CODEMGR_WS}/usr/src/Makefile" ]] || fatal_error "Error: ${CODEMGR_WS}/usr/src/Makefile not found."
2279
2280 echo "\n==== Build environment ====\n" | tee -a $build_environ_file >> $LOGFILE
2281
2282 # System
2283 whence uname | tee -a $build_environ_file >> $LOGFILE
2284 uname -a 2>&1 | tee -a $build_environ_file >> $LOGFILE
2285 echo | tee -a $build_environ_file >> $LOGFILE
2286
2287 # make
2288 whence $MAKE | tee -a $build_environ_file >> $LOGFILE
2289 $MAKE -v | tee -a $build_environ_file >> $LOGFILE
2290 echo "number of concurrent jobs = $DMAKE_MAX_JOBS" |
2291 tee -a $build_environ_file >> $LOGFILE
2292
2293 #
2294 # Report the compiler versions.
2295 #
2296
2297 if [[ ! -f $SRC/Makefile ]]; then
2298 build_ok=n
2299 echo "\nUnable to find \"Makefile\" in $SRC." | \
2300 tee -a $build_environ_file >> $LOGFILE
2301 exit 1
2302 fi
2303
2304 ( cd $SRC
2305 for target in cc-version cc64-version java-version; do
2306 echo
2307 #
2308 # Put statefile somewhere we know we can write to rather than trip
2309 # over a read-only $srcroot.
2310 #
2311 rm -f $TMPDIR/make-state
2312 export SRC
2313 if $MAKE -K $TMPDIR/make-state -e $target 2>/dev/null; then
2314 continue
2315 fi
2316 touch $TMPDIR/nocompiler
2317 done
2318 echo
2319 ) | tee -a $build_environ_file >> $LOGFILE
2320
2321 if [ -f $TMPDIR/nocompiler ]; then
2322 rm -f $TMPDIR/nocompiler
2323 build_ok=n
2324 echo "Aborting due to missing compiler." |
2325 tee -a $build_environ_file >> $LOGFILE
2326 exit 1
2327 fi
2328
2329 # as
2330 whence as | tee -a $build_environ_file >> $LOGFILE
2331 as -V 2>&1 | head -1 | tee -a $build_environ_file >> $LOGFILE
2332 echo | tee -a $build_environ_file >> $LOGFILE
2333
2334 # Check that we're running a capable link-editor
2335 whence ld | tee -a $build_environ_file >> $LOGFILE
2336 LDVER=`ld -V 2>&1`
2337 echo $LDVER | tee -a $build_environ_file >> $LOGFILE
2338 LDVER=`echo $LDVER | sed -e "s/.*-1\.\([0-9]*\).*/\1/"`
2339 if [ `expr $LDVER \< 422` -eq 1 ]; then
2340 echo "The link-editor needs to be at version 422 or higher to build" | \
2341 tee -a $build_environ_file >> $LOGFILE
2342 echo "the latest stuff. Hope your build works." | \
2343 tee -a $build_environ_file >> $LOGFILE
2344 fi
2345
2346 #
2347 # Build and use the workspace's tools if requested
2348 #
2349 if [[ "$t_FLAG" = "y" || "$O_FLAG" = y ]]; then
2350 set_non_debug_build_flags
2351
2352 build_tools ${TOOLS_PROTO}
2353 if [[ $? != 0 && "$t_FLAG" = y ]]; then
2354 use_tools $TOOLS_PROTO
2355 fi
2356 fi
2357
2358 #
2359 # copy ihv proto area in addition to the build itself
2360 #
2361 if [ "$X_FLAG" = "y" ]; then
2362 copy_ihv_proto
2363 fi
2364
2365 if [ "$i_FLAG" = "y" -a "$SH_FLAG" = "y" ]; then
2366 echo "\n==== NOT Building base OS-Net source ====\n" | \
2367 tee -a $LOGFILE >> $mail_msg_file
2368 else
2369 # timestamp the start of the normal build; the findunref tool uses it.
2370 touch $SRC/.build.tstamp
2371
2372 normal_build
2373 fi
2374
2375 #
2376 # Generate the THIRDPARTYLICENSE files if needed. This is done after
2377 # the build, so that dynamically-created license files are there.
2378 # It's done before findunref to help identify license files that need
2379 # to be added to tools/opensolaris/license-list.
2380 #
2381 if [ "$O_FLAG" = y -a "$build_ok" = y ]; then
2382 echo "\n==== Generating THIRDPARTYLICENSE files ====\n" |
2383 tee -a "$mail_msg_file" >> "$LOGFILE"
2384
2385 if [ -d $ROOT/licenses/usr ]; then
2386 ( cd $ROOT/licenses ; \
2387 mktpl $SRC/pkg/license-list ) >> "$LOGFILE" 2>&1
2388 if (( $? != 0 )) ; then
2389 echo "Couldn't create THIRDPARTYLICENSE files" |
2390 tee -a "$mail_msg_file" >> "$LOGFILE"
2391 fi
2392 else
2393 echo "No licenses found under $ROOT/licenses" |
2394 tee -a "$mail_msg_file" >> "$LOGFILE"
2395 fi
2396 fi
2397
2398 ORIG_SRC=$SRC
2399 BINARCHIVE=${CODEMGR_WS}/bin-${MACH}.cpio.Z
2400
2401 if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
2402 save_binaries
2403 fi
2404
2405
2406 # EXPORT_SRC comes after CRYPT_SRC since a domestic build will need
2407 # $SRC pointing to the export_source usr/src.
2408
2409 if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
2410 if [ "$SD_FLAG" = "y" -a $build_ok = y ]; then
2411 set_up_source_build ${CODEMGR_WS} ${CRYPT_SRC} CRYPT_SRC
2412 fi
2413
2414 if [ $build_ok = y ]; then
2415 set_up_source_build ${CODEMGR_WS} ${EXPORT_SRC} EXPORT_SRC
2416 fi
2417 fi
2418
2419 if [ "$SD_FLAG" = "y" -a $build_ok = y ]; then
2420 # drop the crypt files in place.
2421 cd ${EXPORT_SRC}
2422 echo "\nextracting crypt_files.cpio.Z onto export_source.\n" \
2423 >> ${LOGFILE}
2424 zcat ${CODEMGR_WS}/crypt_files.cpio.Z | \
2425 cpio -idmucvB 2>/dev/null >> ${LOGFILE}
2426 if [ "$?" = "0" ]; then
2427 echo "\n==== DOMESTIC extraction succeeded ====\n" \
2428 >> $mail_msg_file
2429 else
2430 echo "\n==== DOMESTIC extraction failed ====\n" \
2431 >> $mail_msg_file
2432 fi
2433
2434 fi
2435
2436 if [ "$SO_FLAG" = "y" -a "$build_ok" = y ]; then
2437 #
2438 # Copy the open sources into their own tree.
2439 # If copy_source fails, it will have already generated an
2440 # error message and set build_ok=n, so we don't need to worry
2441 # about that here.
2442 #
2443 copy_source $CODEMGR_WS $OPEN_SRCDIR OPEN_SOURCE usr/src
2444 fi
2445
2446 if [ "$SO_FLAG" = "y" -a "$build_ok" = y ]; then
2447 SRC=$OPEN_SRCDIR/usr/src
2448 fi
2449
2450 if is_source_build && [ $build_ok = y ] ; then
2451 # remove proto area(s) here, since we don't clobber
2452 rm -rf `allprotos`
2453 if [ "$t_FLAG" = "y" ]; then
2454 set_non_debug_build_flags
2455 ORIG_TOOLS=$TOOLS
2456 #
2457 # SRC was set earlier to point to the source build
2458 # source tree (e.g., $EXPORT_SRC).
2459 #
2460 TOOLS=${SRC}/tools
2461 TOOLS_PROTO=${TOOLS}/${TOOLS_PROTO_REL}; export TOOLS_PROTO
2462 build_tools ${TOOLS_PROTO}
2463 if [[ $? != 0 ]]; then
2464 use_tools ${TOOLS_PROTO}
2465 fi
2466 fi
2467
2468 normal_build
2469 fi
2470
2471 #
2472 # There are several checks that need to look at the proto area, but
2473 # they only need to look at one, and they don't care whether it's
2474 # DEBUG or non-DEBUG.
2475 #
2476 if [[ "$MULTI_PROTO" = yes && "$D_FLAG" = n ]]; then
2477 checkroot=$ROOT-nd
2478 else
2479 checkroot=$ROOT
2480 fi
2481
2482 if [ "$build_ok" = "y" ]; then
2483 echo "\n==== Creating protolist system file at `date` ====" \
2484 >> $LOGFILE
2485 protolist $checkroot > $ATLOG/proto_list_${MACH}
2486 echo "==== protolist system file created at `date` ====\n" \
2487 >> $LOGFILE
2488
2489 if [ "$N_FLAG" != "y" ]; then
2490
2491 E1=
2492 f1=
2493 if [ -d "$SRC/pkgdefs" ]; then
2494 f1="$SRC/pkgdefs/etc/exception_list_$MACH"
2495 if [ "$X_FLAG" = "y" ]; then
2496 f1="$f1 $IA32_IHV_WS/usr/src/pkgdefs/etc/exception_list_$MACH"
2497 fi
2498 fi
2499
2500 for f in $f1; do
2501 if [ -f "$f" ]; then
2502 E1="$E1 -e $f"
2503 fi
2504 done
2505
2506 E2=
2507 f2=
2508 if [ -d "$SRC/pkg" ]; then
2509 f2="$f2 exceptions/packaging"
2510 fi
2511
2512 for f in $f2; do
2513 if [ -f "$f" ]; then
2514 E2="$E2 -e $f"
2515 fi
2516 done
2517
2518 if [ -f "$REF_PROTO_LIST" ]; then
2519 #
2520 # For builds that copy the IHV proto area (-X), add the
2521 # IHV proto list to the reference list if the reference
2522 # was built without -X.
2523 #
2524 # For builds that don't copy the IHV proto area, add the
2525 # IHV proto list to the build's proto list if the
2526 # reference was built with -X.
2527 #
2528 # Use the presence of the first file entry of the cached
2529 # IHV proto list in the reference list to determine
2530 # whether it was built with -X or not.
2531 #
2532 IHV_REF_PROTO_LIST=$SRC/pkg/proto_list_ihv_$MACH
2533 grepfor=$(nawk '$1 == "f" { print $2; exit }' \
2534 $IHV_REF_PROTO_LIST 2> /dev/null)
2535 if [ $? = 0 -a -n "$grepfor" ]; then
2536 if [ "$X_FLAG" = "y" ]; then
2537 grep -w "$grepfor" \
2538 $REF_PROTO_LIST > /dev/null
2539 if [ ! "$?" = "0" ]; then
2540 REF_IHV_PROTO="-d $IHV_REF_PROTO_LIST"
2541 fi
2542 else
2543 grep -w "$grepfor" \
2544 $REF_PROTO_LIST > /dev/null
2545 if [ "$?" = "0" ]; then
2546 IHV_PROTO_LIST="$IHV_REF_PROTO_LIST"
2547 fi
2548 fi
2549 fi
2550 fi
2551 fi
2552
2553 if [ "$N_FLAG" != "y" -a -f $SRC/pkgdefs/Makefile ]; then
2554 echo "\n==== Impact on SVr4 packages ====\n" >> $mail_msg_file
2555 #
2556 # Compare the build's proto list with current package
2557 # definitions to audit the quality of package
2558 # definitions and makefile install targets. Use the
2559 # current exception list.
2560 #
2561 PKGDEFS_LIST=""
2562 for d in $abssrcdirs; do
2563 if [ -d $d/pkgdefs ]; then
2564 PKGDEFS_LIST="$PKGDEFS_LIST -d $d/pkgdefs"
2565 fi
2566 done
2567 if [ "$X_FLAG" = "y" -a \
2568 -d $IA32_IHV_WS/usr/src/pkgdefs ]; then
2569 PKGDEFS_LIST="$PKGDEFS_LIST -d $IA32_IHV_WS/usr/src/pkgdefs"
2570 fi
2571 $PROTOCMPTERSE \
2572 "Files missing from the proto area:" \
2573 "Files missing from packages:" \
2574 "Inconsistencies between pkgdefs and proto area:" \
2575 ${E1} \
2576 ${PKGDEFS_LIST} \
2577 $ATLOG/proto_list_${MACH} \
2578 >> $mail_msg_file
2579 fi
2580
2581 if [ "$N_FLAG" != "y" -a -d $SRC/pkg ]; then
2582 echo "\n==== Validating manifests against proto area ====\n" \
2583 >> $mail_msg_file
2584 ( cd $SRC/pkg ; $MAKE -e protocmp ROOT="$checkroot" ) \
2585 >> $mail_msg_file
2586
2587 fi
2588
2589 if [ "$N_FLAG" != "y" -a -f "$REF_PROTO_LIST" ]; then
2590 echo "\n==== Impact on proto area ====\n" >> $mail_msg_file
2591 if [ -n "$E2" ]; then
2592 ELIST=$E2
2593 else
2594 ELIST=$E1
2595 fi
2596 $PROTOCMPTERSE \
2597 "Files in yesterday's proto area, but not today's:" \
2598 "Files in today's proto area, but not yesterday's:" \
2599 "Files that changed between yesterday and today:" \
2600 ${ELIST} \
2601 -d $REF_PROTO_LIST \
2602 $REF_IHV_PROTO \
2603 $ATLOG/proto_list_${MACH} \
2604 $IHV_PROTO_LIST \
2605 >> $mail_msg_file
2606 fi
2607 fi
2608
2609 if [ "$u_FLAG" = "y" -a "$build_ok" = "y" ]; then
2610 staffer cp $ATLOG/proto_list_${MACH} \
2611 $PARENT_WS/usr/src/proto_list_${MACH}
2612 fi
2613
2614 # Update parent proto area if necessary. This is done now
2615 # so that the proto area has either DEBUG or non-DEBUG kernels.
2616 # Note that this clears out the lock file, so we can dispense with
2617 # the variable now.
2618 if [ "$U_FLAG" = "y" -a "$build_ok" = "y" ]; then
2619 echo "\n==== Copying proto area to $NIGHTLY_PARENT_ROOT ====\n" | \
2620 tee -a $LOGFILE >> $mail_msg_file
2621 rm -rf $NIGHTLY_PARENT_ROOT/*
2622 unset Ulockfile
2623 mkdir -p $NIGHTLY_PARENT_ROOT
2624 if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2625 ( cd $ROOT; tar cf - . |
2626 ( cd $NIGHTLY_PARENT_ROOT; umask 0; tar xpf - ) ) 2>&1 |
2627 tee -a $mail_msg_file >> $LOGFILE
2628 fi
2629 if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
2630 rm -rf $NIGHTLY_PARENT_ROOT-nd/*
2631 mkdir -p $NIGHTLY_PARENT_ROOT-nd
2632 cd $ROOT-nd
2633 ( tar cf - . |
2634 ( cd $NIGHTLY_PARENT_ROOT-nd; umask 0; tar xpf - ) ) 2>&1 |
2635 tee -a $mail_msg_file >> $LOGFILE
2636 fi
2637 if [ -n "${NIGHTLY_PARENT_TOOLS_ROOT}" ]; then
2638 echo "\n==== Copying tools proto area to $NIGHTLY_PARENT_TOOLS_ROOT ====\n" | \
2639 tee -a $LOGFILE >> $mail_msg_file
2640 rm -rf $NIGHTLY_PARENT_TOOLS_ROOT/*
2641 mkdir -p $NIGHTLY_PARENT_TOOLS_ROOT
2642 if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2643 ( cd $TOOLS_PROTO; tar cf - . |
2644 ( cd $NIGHTLY_PARENT_TOOLS_ROOT;
2645 umask 0; tar xpf - ) ) 2>&1 |
2646 tee -a $mail_msg_file >> $LOGFILE
2647 fi
2648 fi
2649 fi
2650
2651 #
2652 # ELF verification: ABI (-A) and runtime (-r) checks
2653 #
2654 if [[ ($build_ok = y) && ( ($A_FLAG = y) || ($r_FLAG = y) ) ]]; then
2655 # Directory ELF-data.$MACH holds the files produced by these tests.
2656 elf_ddir=$SRC/ELF-data.$MACH
2657
2658 # If there is a previous ELF-data backup directory, remove it. Then,
2659 # rotate current ELF-data directory into its place and create a new
2660 # empty directory
2661 rm -rf $elf_ddir.ref
2662 if [[ -d $elf_ddir ]]; then
2663 mv $elf_ddir $elf_ddir.ref
2664 fi
2665 mkdir -p $elf_ddir
2666
2667 # Call find_elf to produce a list of the ELF objects in the proto area.
2668 # This list is passed to check_rtime and interface_check, preventing
2669 # them from separately calling find_elf to do the same work twice.
2670 find_elf -fr $checkroot > $elf_ddir/object_list
2671
2672 if [[ $A_FLAG = y ]]; then
2673 echo "\n==== Check versioning and ABI information ====\n" | \
2674 tee -a $LOGFILE >> $mail_msg_file
2675
2676 # Produce interface description for the proto. Report errors.
2677 interface_check -o -w $elf_ddir -f object_list \
2678 -i interface -E interface.err
2679 if [[ -s $elf_ddir/interface.err ]]; then
2680 tee -a $LOGFILE < $elf_ddir/interface.err \
2681 >> $mail_msg_file
2682 fi
2683
2684 # If ELF_DATA_BASELINE_DIR is defined, compare the new interface
2685 # description file to that from the baseline gate. Issue a
2686 # warning if the baseline is not present, and keep going.
2687 if [[ "$ELF_DATA_BASELINE_DIR" != '' ]]; then
2688 base_ifile="$ELF_DATA_BASELINE_DIR/interface"
2689
2690 echo "\n==== Compare versioning and ABI information" \
2691 "to baseline ====\n" | \
2692 tee -a $LOGFILE >> $mail_msg_file
2693 echo "Baseline: $base_ifile\n" >> $LOGFILE
2694
2695 if [[ -f $base_ifile ]]; then
2696 interface_cmp -d -o $base_ifile \
2697 $elf_ddir/interface > $elf_ddir/interface.cmp
2698 if [[ -s $elf_ddir/interface.cmp ]]; then
2699 echo | tee -a $LOGFILE >> $mail_msg_file
2700 tee -a $LOGFILE < \
2701 $elf_ddir/interface.cmp \
2702 >> $mail_msg_file
2703 fi
2704 else
2705 echo "baseline not available. comparison" \
2706 "skipped" | \
2707 tee -a $LOGFILE >> $mail_msg_file
2708 fi
2709
2710 fi
2711 fi
2712
2713 if [[ $r_FLAG = y ]]; then
2714 echo "\n==== Check ELF runtime attributes ====\n" | \
2715 tee -a $LOGFILE >> $mail_msg_file
2716
2717 # If we're doing a DEBUG build the proto area will be left
2718 # with debuggable objects, thus don't assert -s.
2719 if [[ $D_FLAG = y ]]; then
2720 rtime_sflag=""
2721 else
2722 rtime_sflag="-s"
2723 fi
2724 check_rtime -i -m -v $rtime_sflag -o -w $elf_ddir \
2725 -D object_list -f object_list -E runtime.err \
2726 -I runtime.attr.raw
2727
2728 # check_rtime -I output needs to be sorted in order to
2729 # compare it to that from previous builds.
2730 sort $elf_ddir/runtime.attr.raw > $elf_ddir/runtime.attr
2731 rm $elf_ddir/runtime.attr.raw
2732
2733 # Report errors
2734 if [[ -s $elf_ddir/runtime.err ]]; then
2735 tee -a $LOGFILE < $elf_ddir/runtime.err \
2736 >> $mail_msg_file
2737 fi
2738
2739 # If there is an ELF-data directory from a previous build,
2740 # then diff the attr files. These files contain information
2741 # about dependencies, versioning, and runpaths. There is some
2742 # overlap with the ABI checking done above, but this also
2743 # flushes out non-ABI interface differences along with the
2744 # other information.
2745 echo "\n==== Diff ELF runtime attributes" \
2746 "(since last build) ====\n" | \
2747 tee -a $LOGFILE >> $mail_msg_file >> $mail_msg_file
2748
2749 if [[ -f $elf_ddir.ref/runtime.attr ]]; then
2750 diff $elf_ddir.ref/runtime.attr \
2751 $elf_ddir/runtime.attr \
2752 >> $mail_msg_file
2753 fi
2754 fi
2755
2756 # If -u set, copy contents of ELF-data.$MACH to the parent workspace.
2757 if [[ "$u_FLAG" = "y" ]]; then
2758 p_elf_ddir=$PARENT_WS/usr/src/ELF-data.$MACH
2759
2760 # If parent lacks the ELF-data.$MACH directory, create it
2761 if [[ ! -d $p_elf_ddir ]]; then
2762 staffer mkdir -p $p_elf_ddir
2763 fi
2764
2765 # These files are used asynchronously by other builds for ABI
2766 # verification, as above for the -A option. As such, we require
2767 # the file replacement to be atomic. Copy the data to a temp
2768 # file in the same filesystem and then rename into place.
2769 (
2770 cd $elf_ddir
2771 for elf_dfile in *; do
2772 staffer cp $elf_dfile \
2773 ${p_elf_ddir}/${elf_dfile}.new
2774 staffer mv -f ${p_elf_ddir}/${elf_dfile}.new \
2775 ${p_elf_ddir}/${elf_dfile}
2776 done
2777 )
2778 fi
2779 fi
2780
2781 # DEBUG lint of kernel begins
2782
2783 if [ "$i_CMD_LINE_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
2784 if [ "$LINTDIRS" = "" ]; then
2785 # LINTDIRS="$SRC/uts y $SRC/stand y $SRC/psm y"
2786 LINTDIRS="$SRC y"
2787 fi
2788 set $LINTDIRS
2789 while [ $# -gt 0 ]; do
2790 dolint $1 $2; shift; shift
2791 done
2792 else
2793 echo "\n==== No '$MAKE lint' ====\n" >> $LOGFILE
2794 fi
2795
2796 # "make check" begins
2797
2798 if [ "$i_CMD_LINE_FLAG" = "n" -a "$C_FLAG" = "y" ]; then
2799 # remove old check.out
2800 rm -f $SRC/check.out
2801
2802 rm -f $SRC/check-${MACH}.out
2803 cd $SRC
2804 $MAKE -ek check ROOT="$checkroot" 2>&1 | tee -a $SRC/check-${MACH}.out \
2805 >> $LOGFILE
2806 echo "\n==== cstyle/hdrchk errors ====\n" >> $mail_msg_file
2807
2808 grep ":" $SRC/check-${MACH}.out |
2809 egrep -v "Ignoring unknown host" | \
2810 sort | uniq >> $mail_msg_file
2811 else
2812 echo "\n==== No '$MAKE check' ====\n" >> $LOGFILE
2813 fi
2814
2815 echo "\n==== Find core files ====\n" | \
2816 tee -a $LOGFILE >> $mail_msg_file
2817
2818 find $abssrcdirs -name core -a -type f -exec file {} \; | \
2819 tee -a $LOGFILE >> $mail_msg_file
2820
2821 if [ "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2822 echo "\n==== Diff unreferenced files (since last build) ====\n" \
2823 | tee -a $LOGFILE >>$mail_msg_file
2824 rm -f $SRC/unref-${MACH}.ref
2825 if [ -f $SRC/unref-${MACH}.out ]; then
2826 mv $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2827 fi
2828
2829 findunref -S $SCM_TYPE -t $SRC/.build.tstamp -s usr $CODEMGR_WS \
2830 ${TOOLS}/findunref/exception_list 2>> $mail_msg_file | \
2831 sort > $SRC/unref-${MACH}.out
2832
2833 if [ ! -f $SRC/unref-${MACH}.ref ]; then
2834 cp $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2835 fi
2836
2837 diff $SRC/unref-${MACH}.ref $SRC/unref-${MACH}.out >>$mail_msg_file
2838 fi
2839
2840 #
2841 # Generate the OpenSolaris deliverables if requested. Some of these
2842 # steps need to come after findunref and are commented below.
2843 #
2844
2845 # If we are doing an OpenSolaris _source_ build (-S O) then we do
2846 # not have usr/closed available to us to generate closedbins from,
2847 # so skip this part.
2848 if [ "$SO_FLAG" = n -a "$O_FLAG" = y -a "$build_ok" = y ]; then
2849 echo "\n==== Generating OpenSolaris tarballs ====\n" | \
2850 tee -a $mail_msg_file >> $LOGFILE
2851
2852 cd $CODEMGR_WS
2853
2854 #
2855 # This step grovels through the package manifests, so it
2856 # must come after findunref.
2857 #
2858 # We assume no DEBUG vs non-DEBUG package content variation
2859 # here; if that changes, then the "make all" in $SRC/pkg will
2860 # need to be moved into the conditionals and repeated for each
2861 # different build.
2862 #
2863 echo "Generating closed binaries tarball(s)..." >> $LOGFILE
2864 closed_basename=on-closed-bins
2865 if [ "$D_FLAG" = y ]; then
2866 bindrop "$closed_basename" >>"$LOGFILE" 2>&1
2867 if (( $? != 0 )) ; then
2868 echo "Couldn't create DEBUG closed binaries." |
2869 tee -a $mail_msg_file >> $LOGFILE
2870 build_ok=n
2871 fi
2872 fi
2873 if [ "$F_FLAG" = n ]; then
2874 bindrop -n "$closed_basename-nd" >>"$LOGFILE" 2>&1
2875 if (( $? != 0 )) ; then
2876 echo "Couldn't create non-DEBUG closed binaries." |
2877 tee -a $mail_msg_file >> $LOGFILE
2878 build_ok=n
2879 fi
2880 fi
2881
2882 echo "Generating README.opensolaris..." >> $LOGFILE
2883 cat $SRC/tools/opensolaris/README.opensolaris.tmpl | \
2884 mkreadme_osol $CODEMGR_WS/README.opensolaris >> $LOGFILE 2>&1
2885 if (( $? != 0 )) ; then
2886 echo "Couldn't create README.opensolaris." |
2887 tee -a $mail_msg_file >> $LOGFILE
2888 build_ok=n
2889 fi
2890 fi
2891
2892 # Verify that the usual lists of files, such as exception lists,
2893 # contain only valid references to files. If the build has failed,
2894 # then don't check the proto area.
2895 CHECK_PATHS=${CHECK_PATHS:-y}
2896 if [ "$CHECK_PATHS" = y -a "$N_FLAG" != y ]; then
2897 echo "\n==== Check lists of files ====\n" | tee -a $LOGFILE \
2898 >>$mail_msg_file
2899 arg=-b
2900 [ "$build_ok" = y ] && arg=
2901 checkpaths $arg $checkroot 2>&1 | tee -a $LOGFILE >>$mail_msg_file
2902 fi
2903
2904 if [ "$M_FLAG" != "y" -a "$build_ok" = y ]; then
2905 echo "\n==== Impact on file permissions ====\n" \
2906 >> $mail_msg_file
2907
2908 abspkgdefs=
2909 abspkg=
2910 for d in $abssrcdirs; do
2911 if [ -d "$d/pkgdefs" ]; then
2912 abspkgdefs="$abspkgdefs $d"
2913 fi
2914 if [ -d "$d/pkg" ]; then
2915 abspkg="$abspkg $d"
2916 fi
2917 done
2918
2919 if [ -n "$abspkgdefs" ]; then
2920 pmodes -qvdP \
2921 `find $abspkgdefs -name pkginfo.tmpl -print -o \
2922 -name .del\* -prune | sed -e 's:/pkginfo.tmpl$::' | \
2923 sort -u` >> $mail_msg_file
2924 fi
2925
2926 if [ -n "$abspkg" ]; then
2927 for d in "$abspkg"; do
2928 ( cd $d/pkg ; $MAKE -e pmodes ) >> $mail_msg_file
2929 done
2930 fi
2931 fi
2932
2933 if [ "$w_FLAG" = "y" -a "$build_ok" = "y" ]; then
2934 if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2935 do_wsdiff DEBUG $ROOT.prev $ROOT
2936 fi
2937
2938 if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
2939 do_wsdiff non-DEBUG $ROOT-nd.prev $ROOT-nd
2940 fi
2941 fi
2942
2943 END_DATE=`date`
2944 echo "==== Nightly $maketype build completed: $END_DATE ====" | \
2945 tee -a $LOGFILE >> $build_time_file
2946
2947 typeset -i10 hours
2948 typeset -Z2 minutes
2949 typeset -Z2 seconds
2950
2951 elapsed_time=$SECONDS
2952 ((hours = elapsed_time / 3600 ))
2953 ((minutes = elapsed_time / 60 % 60))
2954 ((seconds = elapsed_time % 60))
2955
2956 echo "\n==== Total build time ====" | \
2957 tee -a $LOGFILE >> $build_time_file
2958 echo "\nreal ${hours}:${minutes}:${seconds}" | \
2959 tee -a $LOGFILE >> $build_time_file
2960
2961 if [ "$u_FLAG" = "y" -a "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2962 staffer cp ${SRC}/unref-${MACH}.out $PARENT_WS/usr/src/
2963
2964 #
2965 # Produce a master list of unreferenced files -- ideally, we'd
2966 # generate the master just once after all of the nightlies
2967 # have finished, but there's no simple way to know when that
2968 # will be. Instead, we assume that we're the last nightly to
2969 # finish and merge all of the unref-${MACH}.out files in
2970 # $PARENT_WS/usr/src/. If we are in fact the final ${MACH} to
2971 # finish, then this file will be the authoritative master
2972 # list. Otherwise, another ${MACH}'s nightly will eventually
2973 # overwrite ours with its own master, but in the meantime our
2974 # temporary "master" will be no worse than any older master
2975 # which was already on the parent.
2976 #
2977
2978 set -- $PARENT_WS/usr/src/unref-*.out
2979 cp "$1" ${TMPDIR}/unref.merge
2980 shift
2981
2982 for unreffile; do
2983 comm -12 ${TMPDIR}/unref.merge "$unreffile" > ${TMPDIR}/unref.$$
2984 mv ${TMPDIR}/unref.$$ ${TMPDIR}/unref.merge
2985 done
2986
2987 staffer cp ${TMPDIR}/unref.merge $PARENT_WS/usr/src/unrefmaster.out
2988 fi
2989
2990 #
2991 # All done save for the sweeping up.
2992 # (whichever exit we hit here will trigger the "cleanup" trap which
2993 # optionally sends mail on completion).
2994 #
2995 if [ "$build_ok" = "y" ]; then
2996 exit 0
2997 fi
2998 exit 1